require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SPARC_FLOPPY_H)) {
    eval 'sub __ASM_SPARC_FLOPPY_H () {1;}' unless defined(&__ASM_SPARC_FLOPPY_H);
    require 'asm/page.ph';
    require 'asm/pgtable.ph';
    require 'asm/system.ph';
    require 'asm/idprom.ph';
    require 'asm/machines.ph';
    require 'asm/oplib.ph';
    require 'asm/auxio.ph';
    require 'asm/irq.ph';
    undef(&release_region) if defined(&release_region);
    undef(&check_region) if defined(&check_region);
    undef(&request_region) if defined(&request_region);
    eval 'sub release_region {
        my($X, $Y) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&release_region);
    eval 'sub check_region {
        my($X, $Y) = @_;
	    eval q((0));
    }' unless defined(&check_region);
    eval 'sub request_region {
        my($X, $Y, $Z) = @_;
	    eval q((1));
    }' unless defined(&request_region);
    eval 'sub dcr_82072 () { &status_82072;}' unless defined(&dcr_82072);
    eval 'sub status1_82077 () { &status_82072;}' unless defined(&status1_82077);
    eval 'sub status2_82077 () { &data_82072;}' unless defined(&status2_82077);
    eval 'sub drs_82077 () { &status_82077;}' unless defined(&drs_82077);
    eval 'sub dcr_82077 () { &dir_82077;}' unless defined(&dcr_82077);
    eval 'sub fd_inb {
        my($port) = @_;
	    eval q( ($sun_fdops->{fd_inb})($port));
    }' unless defined(&fd_inb);
    eval 'sub fd_outb {
        my($value,$port) = @_;
	    eval q( ($sun_fdops->{fd_outb})($value,$port));
    }' unless defined(&fd_outb);
    eval 'sub fd_enable_dma () {
        eval q( &sun_fd_enable_dma());
    }' unless defined(&fd_enable_dma);
    eval 'sub fd_disable_dma () {
        eval q( &sun_fd_disable_dma());
    }' unless defined(&fd_disable_dma);
    eval 'sub fd_request_dma () {
        eval q((0));
    }' unless defined(&fd_request_dma);
    eval 'sub fd_free_dma () {
        eval q();
    }' unless defined(&fd_free_dma);
    eval 'sub fd_clear_dma_ff () {
        eval q();
    }' unless defined(&fd_clear_dma_ff);
    eval 'sub fd_set_dma_mode {
        my($mode) = @_;
	    eval q( &sun_fd_set_dma_mode($mode));
    }' unless defined(&fd_set_dma_mode);
    eval 'sub fd_set_dma_addr {
        my($addr) = @_;
	    eval q( &sun_fd_set_dma_addr($addr));
    }' unless defined(&fd_set_dma_addr);
    eval 'sub fd_set_dma_count {
        my($count) = @_;
	    eval q( &sun_fd_set_dma_count($count));
    }' unless defined(&fd_set_dma_count);
    eval 'sub fd_enable_irq () {
        eval q();
    }' unless defined(&fd_enable_irq);
    eval 'sub fd_disable_irq () {
        eval q();
    }' unless defined(&fd_disable_irq);
    eval 'sub fd_cacheflush {
        my($addr, $size) = @_;
	    eval q();
    }' unless defined(&fd_cacheflush);
    eval 'sub fd_request_irq () {
        eval q( &sun_fd_request_irq());
    }' unless defined(&fd_request_irq);
    eval 'sub fd_free_irq () {
        eval q();
    }' unless defined(&fd_free_irq);
    if(0) {
	eval 'sub fd_dma_mem_alloc {
	    my($size) = @_;
    	    eval q((  &vmalloc($size)));
	}' unless defined(&fd_dma_mem_alloc);
	eval 'sub fd_dma_mem_free {
	    my($addr,$size) = @_;
    	    eval q(( &vfree(( &void *)($addr))));
	}' unless defined(&fd_dma_mem_free);
    }
    eval 'sub FLOPPY_MOTOR_MASK () {0x10;}' unless defined(&FLOPPY_MOTOR_MASK);
    eval 'sub get_dma_residue {
        my($x) = @_;
	    eval q((0));
    }' unless defined(&get_dma_residue);
    eval 'sub FLOPPY0_TYPE () {4;}' unless defined(&FLOPPY0_TYPE);
    eval 'sub FLOPPY1_TYPE () {0;}' unless defined(&FLOPPY1_TYPE);
    undef(&HAVE_DISABLE_HLT) if defined(&HAVE_DISABLE_HLT);
    eval 'sub FDC1 () { &sun_floppy_init();}' unless defined(&FDC1);
    eval 'sub N_FDC () {1;}' unless defined(&N_FDC);
    eval 'sub N_DRIVE () {8;}' unless defined(&N_DRIVE);
    eval 'sub CROSS_64KB {
        my($a,$s) = @_;
	    eval q((0));
    }' unless defined(&CROSS_64KB);
    eval 'sub sun_fd_disable_dma {
        my($void) = @_;
	    eval q({  &doing_pdma = 0;  &if ( &pdma_base) {  &mmu_unlockarea( &pdma_base,  &pdma_areasize);  &pdma_base = 0; } });
    }' unless defined(&sun_fd_disable_dma);
    eval 'sub sun_fd_set_dma_mode {
        my($mode) = @_;
	    eval q({  &switch($mode) {  &case  &DMA_MODE_READ:  &doing_pdma = 1;  &break;  &case  &DMA_MODE_WRITE:  &doing_pdma = 2;  &break;  &default:  &printk(\\"Unknown dma mode %d\\\\n\\", $mode);  &panic(\\"floppy: Giving up...\\"); } });
    }' unless defined(&sun_fd_set_dma_mode);
    eval 'sub sun_fd_set_dma_addr {
        my($buffer) = @_;
	    eval q({  &pdma_vaddr = $buffer; });
    }' unless defined(&sun_fd_set_dma_addr);
    eval 'sub sun_fd_set_dma_count {
        my($length) = @_;
	    eval q({  &pdma_size = $length; });
    }' unless defined(&sun_fd_set_dma_count);
    eval 'sub sun_fd_enable_dma {
        my($void) = @_;
	    eval q({  &pdma_vaddr =  &mmu_lockarea( &pdma_vaddr,  &pdma_size);  &pdma_base =  &pdma_vaddr;  &pdma_areasize =  &pdma_size; });
    }' unless defined(&sun_fd_enable_dma);
    eval 'sub fd_eject {
        my($drive) = @_;
	    eval q( &sparc_eject());
    }' unless defined(&fd_eject);
    eval 'sub EXTRA_FLOPPY_PARAMS () {1;}' unless defined(&EXTRA_FLOPPY_PARAMS);
}
1;
