require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_IO_H)) {
    eval 'sub __SPARC_IO_H () {1;}' unless defined(&__SPARC_IO_H);
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'linux/ioport.ph';
    require 'asm/page.ph';
    require 'asm/system.ph';
    eval 'sub page_to_phys {
        my($page) = @_;
	    eval q(((($page) -  &mem_map) <<  &PAGE_SHIFT));
    }' unless defined(&page_to_phys);
    eval 'sub flip_dword {
        my($l) = @_;
	    eval q({ (($l&0xff)<<24) | ((($l>>8)&0xff)<<16) | ((($l>>16)&0xff)<<8)| (($l>>24)&0xff); });
    }' unless defined(&flip_dword);
    eval 'sub flip_word {
        my($w) = @_;
	    eval q({ (($w&0xff) << 8) | (($w>>8)&0xff); });
    }' unless defined(&flip_word);
    eval 'sub __raw_readw {
        my($addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr; });
    }' unless defined(&__raw_readw);
    eval 'sub __raw_readl {
        my($addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr; });
    }' unless defined(&__raw_readl);
    eval 'sub __raw_writeb {
        my($b,$addr) = @_;
	    eval q({ *( &volatile  &u8 *)$addr = $b; });
    }' unless defined(&__raw_writeb);
    eval 'sub __raw_writew {
        my($w,$addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr = $w; });
    }' unless defined(&__raw_writew);
    eval 'sub __raw_writel {
        my($l,$addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr = $l; });
    }' unless defined(&__raw_writel);
    eval 'sub __readb {
        my($addr) = @_;
	    eval q({ *( &volatile  &u8 *)$addr; });
    }' unless defined(&__readb);
    eval 'sub __readw {
        my($addr) = @_;
	    eval q({  &flip_word(*( &volatile  &u16 *)$addr); });
    }' unless defined(&__readw);
    eval 'sub __readl {
        my($addr) = @_;
	    eval q({  &flip_dword(*( &volatile  &u32 *)$addr); });
    }' unless defined(&__readl);
    eval 'sub __writeb {
        my($b,$addr) = @_;
	    eval q({ *( &volatile  &u8 *)$addr = $b; });
    }' unless defined(&__writeb);
    eval 'sub __writew {
        my($w,$addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr =  &flip_word($w); });
    }' unless defined(&__writew);
    eval 'sub __writel {
        my($l,$addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr =  &flip_dword($l); });
    }' unless defined(&__writel);
    eval 'sub readb {
        my($__addr) = @_;
	    eval q( &__readb(($__addr)));
    }' unless defined(&readb);
    eval 'sub readw {
        my($__addr) = @_;
	    eval q( &__readw(($__addr)));
    }' unless defined(&readw);
    eval 'sub readl {
        my($__addr) = @_;
	    eval q( &__readl(($__addr)));
    }' unless defined(&readl);
    eval 'sub readb_relaxed {
        my($__addr) = @_;
	    eval q( &readb($__addr));
    }' unless defined(&readb_relaxed);
    eval 'sub readw_relaxed {
        my($__addr) = @_;
	    eval q( &readw($__addr));
    }' unless defined(&readw_relaxed);
    eval 'sub readl_relaxed {
        my($__addr) = @_;
	    eval q( &readl($__addr));
    }' unless defined(&readl_relaxed);
    eval 'sub writeb {
        my($__b, $__addr) = @_;
	    eval q( &__writeb(,($__addr)));
    }' unless defined(&writeb);
    eval 'sub writew {
        my($__w, $__addr) = @_;
	    eval q( &__writew(,($__addr)));
    }' unless defined(&writew);
    eval 'sub writel {
        my($__l, $__addr) = @_;
	    eval q( &__writel(,($__addr)));
    }' unless defined(&writel);
    eval 'sub inb_local {
        my($__addr) = @_;
	    eval q( &__readb(($__addr)));
    }' unless defined(&inb_local);
    eval 'sub inb {
        my($__addr) = @_;
	    eval q( &__readb(($__addr)));
    }' unless defined(&inb);
    eval 'sub inw {
        my($__addr) = @_;
	    eval q( &__readw(($__addr)));
    }' unless defined(&inw);
    eval 'sub inl {
        my($__addr) = @_;
	    eval q( &__readl(($__addr)));
    }' unless defined(&inl);
    eval 'sub outb_local {
        my($__b, $__addr) = @_;
	    eval q( &__writeb($__b, ($__addr)));
    }' unless defined(&outb_local);
    eval 'sub outb {
        my($__b, $__addr) = @_;
	    eval q( &__writeb($__b, ($__addr)));
    }' unless defined(&outb);
    eval 'sub outw {
        my($__w, $__addr) = @_;
	    eval q( &__writew($__w, ($__addr)));
    }' unless defined(&outw);
    eval 'sub outl {
        my($__l, $__addr) = @_;
	    eval q( &__writel($__l, ($__addr)));
    }' unless defined(&outl);
    eval 'sub inb_p {
        my($__addr) = @_;
	    eval q( &inb($__addr));
    }' unless defined(&inb_p);
    eval 'sub outb_p {
        my($__b, $__addr) = @_;
	    eval q( &outb($__b, $__addr));
    }' unless defined(&outb_p);
    eval 'sub inw_p {
        my($__addr) = @_;
	    eval q( &inw($__addr));
    }' unless defined(&inw_p);
    eval 'sub outw_p {
        my($__w, $__addr) = @_;
	    eval q( &outw($__w, $__addr));
    }' unless defined(&outw_p);
    eval 'sub inl_p {
        my($__addr) = @_;
	    eval q( &inl($__addr));
    }' unless defined(&inl_p);
    eval 'sub outl_p {
        my($__l, $__addr) = @_;
	    eval q( &outl($__l, $__addr));
    }' unless defined(&outl_p);
    eval 'sub IO_SPACE_LIMIT () {0xffffffff;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub _sbus_readw {
        my($addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr; });
    }' unless defined(&_sbus_readw);
    eval 'sub _sbus_readl {
        my($addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr; });
    }' unless defined(&_sbus_readl);
    eval 'sub _sbus_writeb {
        my($b,$addr) = @_;
	    eval q({ *( &volatile  &u8 *)$addr = $b; });
    }' unless defined(&_sbus_writeb);
    eval 'sub _sbus_writew {
        my($w,$addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr = $w; });
    }' unless defined(&_sbus_writew);
    eval 'sub _sbus_writel {
        my($l,$addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr = $l; });
    }' unless defined(&_sbus_writel);
    eval 'sub sbus_readb {
        my($__addr) = @_;
	    eval q( &_sbus_readb(($__addr)));
    }' unless defined(&sbus_readb);
    eval 'sub sbus_readw {
        my($__addr) = @_;
	    eval q( &_sbus_readw(($__addr)));
    }' unless defined(&sbus_readw);
    eval 'sub sbus_readl {
        my($__addr) = @_;
	    eval q( &_sbus_readl(($__addr)));
    }' unless defined(&sbus_readl);
    eval 'sub sbus_writeb {
        my($__b, $__addr) = @_;
	    eval q( &_sbus_writeb($__b, ($__addr)));
    }' unless defined(&sbus_writeb);
    eval 'sub sbus_writew {
        my($__w, $__addr) = @_;
	    eval q( &_sbus_writew($__w, ($__addr)));
    }' unless defined(&sbus_writew);
    eval 'sub sbus_writel {
        my($__l, $__addr) = @_;
	    eval q( &_sbus_writel($__l, ($__addr)));
    }' unless defined(&sbus_writel);
    eval 'sub void {
        eval q(* &sbus_memset_io( &void * &__dst, \'int\'  &c,  &__kernel_size_t  &n) { my $dst =  &__dst;  &while( &n--) {  &sbus_writeb( &c,  $dst);  $dst++; } ( &void *)  $dst; });
    }' unless defined(&void);
    if(defined(&__KERNEL__)) {
	eval 'sub ioremap_nocache {
	    my($X,$Y) = @_;
    	    eval q( &ioremap(($X),($Y)));
	}' unless defined(&ioremap_nocache);
	eval 'sub RTC_PORT {
	    my($x) = @_;
    	    eval q(( &rtc_port + ($x)));
	}' unless defined(&RTC_PORT);
	eval 'sub RTC_ALWAYS_BCD () {0;}' unless defined(&RTC_ALWAYS_BCD);
	eval 'sub dma_cache_inv {
	    my($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    my($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    my($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
}
1;
