require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_IOMMU_H)) {
    eval 'sub _SPARC_IOMMU_H () {1;}' unless defined(&_SPARC_IOMMU_H);
    require 'asm/page.ph';
    require 'asm/bitext.ph';
    eval 'sub IOMMU_CTRL_IMPL () {0xf0000000;}' unless defined(&IOMMU_CTRL_IMPL);
    eval 'sub IOMMU_CTRL_VERS () {0xf000000;}' unless defined(&IOMMU_CTRL_VERS);
    eval 'sub IOMMU_CTRL_RNGE () {0x1c;}' unless defined(&IOMMU_CTRL_RNGE);
    eval 'sub IOMMU_RNGE_16MB () {0x;}' unless defined(&IOMMU_RNGE_16MB);
    eval 'sub IOMMU_RNGE_32MB () {0x4;}' unless defined(&IOMMU_RNGE_32MB);
    eval 'sub IOMMU_RNGE_64MB () {0x8;}' unless defined(&IOMMU_RNGE_64MB);
    eval 'sub IOMMU_RNGE_128MB () {0xc;}' unless defined(&IOMMU_RNGE_128MB);
    eval 'sub IOMMU_RNGE_256MB () {0x10;}' unless defined(&IOMMU_RNGE_256MB);
    eval 'sub IOMMU_RNGE_512MB () {0x14;}' unless defined(&IOMMU_RNGE_512MB);
    eval 'sub IOMMU_RNGE_1GB () {0x18;}' unless defined(&IOMMU_RNGE_1GB);
    eval 'sub IOMMU_RNGE_2GB () {0x1c;}' unless defined(&IOMMU_RNGE_2GB);
    eval 'sub IOMMU_CTRL_ENAB () {0x1;}' unless defined(&IOMMU_CTRL_ENAB);
    eval 'sub IOMMU_AFSR_ERR () {0x80000000;}' unless defined(&IOMMU_AFSR_ERR);
    eval 'sub IOMMU_AFSR_LE () {0x40000000;}' unless defined(&IOMMU_AFSR_LE);
    eval 'sub IOMMU_AFSR_TO () {0x20000000;}' unless defined(&IOMMU_AFSR_TO);
    eval 'sub IOMMU_AFSR_BE () {0x10000000;}' unless defined(&IOMMU_AFSR_BE);
    eval 'sub IOMMU_AFSR_SIZE () {0xe000000;}' unless defined(&IOMMU_AFSR_SIZE);
    eval 'sub IOMMU_AFSR_S () {0x1000000;}' unless defined(&IOMMU_AFSR_S);
    eval 'sub IOMMU_AFSR_RESV () {0xf00000;}' unless defined(&IOMMU_AFSR_RESV);
    eval 'sub IOMMU_AFSR_ME () {0x80000;}' unless defined(&IOMMU_AFSR_ME);
    eval 'sub IOMMU_AFSR_RD () {0x40000;}' unless defined(&IOMMU_AFSR_RD);
    eval 'sub IOMMU_AFSR_FAV () {0x20000;}' unless defined(&IOMMU_AFSR_FAV);
    eval 'sub IOMMU_SBCFG_SAB30 () {0x10000;}' unless defined(&IOMMU_SBCFG_SAB30);
    eval 'sub IOMMU_SBCFG_BA16 () {0x4;}' unless defined(&IOMMU_SBCFG_BA16);
    eval 'sub IOMMU_SBCFG_BA8 () {0x2;}' unless defined(&IOMMU_SBCFG_BA8);
    eval 'sub IOMMU_SBCFG_BYPASS () {0x1;}' unless defined(&IOMMU_SBCFG_BYPASS);
    eval 'sub IOMMU_MFSR_ERR () {0x80000000;}' unless defined(&IOMMU_MFSR_ERR);
    eval 'sub IOMMU_MFSR_S () {0x1000000;}' unless defined(&IOMMU_MFSR_S);
    eval 'sub IOMMU_MFSR_CPU () {0x800000;}' unless defined(&IOMMU_MFSR_CPU);
    eval 'sub IOMMU_MFSR_ME () {0x80000;}' unless defined(&IOMMU_MFSR_ME);
    eval 'sub IOMMU_MFSR_PERR () {0x6000;}' unless defined(&IOMMU_MFSR_PERR);
    eval 'sub IOMMU_MFSR_BM () {0x1000;}' unless defined(&IOMMU_MFSR_BM);
    eval 'sub IOMMU_MFSR_C () {0x800;}' unless defined(&IOMMU_MFSR_C);
    eval 'sub IOMMU_MFSR_RTYP () {0xf0;}' unless defined(&IOMMU_MFSR_RTYP);
    eval 'sub IOMMU_MID_SBAE () {0x1f0000;}' unless defined(&IOMMU_MID_SBAE);
    eval 'sub IOMMU_MID_SE () {0x100000;}' unless defined(&IOMMU_MID_SE);
    eval 'sub IOMMU_MID_SB3 () {0x80000;}' unless defined(&IOMMU_MID_SB3);
    eval 'sub IOMMU_MID_SB2 () {0x40000;}' unless defined(&IOMMU_MID_SB2);
    eval 'sub IOMMU_MID_SB1 () {0x20000;}' unless defined(&IOMMU_MID_SB1);
    eval 'sub IOMMU_MID_SB0 () {0x10000;}' unless defined(&IOMMU_MID_SB0);
    eval 'sub IOMMU_MID_MID () {0xf;}' unless defined(&IOMMU_MID_MID);
    eval 'sub IOPTE_PAGE () {0x7ffff00;}' unless defined(&IOPTE_PAGE);
    eval 'sub IOPTE_CACHE () {0x80;}' unless defined(&IOPTE_CACHE);
    eval 'sub IOPTE_WRITE () {0x4;}' unless defined(&IOPTE_WRITE);
    eval 'sub IOPTE_VALID () {0x2;}' unless defined(&IOPTE_VALID);
    eval 'sub IOPTE_WAZ () {0x1;}' unless defined(&IOPTE_WAZ);
    eval 'sub iommu_invalidate {
        my($regs) = @_;
	    eval q({  ($regs->{tlbflush}) = 0; });
    }' unless defined(&iommu_invalidate);
    eval 'sub iommu_invalidate_page {
        my($regs,$ba) = @_;
	    eval q({  ($regs->{pageflush}) = ($ba &  &PAGE_MASK); });
    }' unless defined(&iommu_invalidate_page);
}
1;
