require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_IRQ_H)) {
    eval 'sub _SPARC_IRQ_H () {1;}' unless defined(&_SPARC_IRQ_H);
    require 'linux/config.ph';
    require 'linux/linkage.ph';
    require 'linux/threads.ph';
    require 'linux/interrupt.ph';
    require 'asm/system.ph';
    require 'asm/btfixup.ph';
    eval 'sub __irq_ino {
        my($irq) = @_;
	    eval q($irq);
    }' unless defined(&__irq_ino);
    eval 'sub __irq_pil {
        my($irq) = @_;
	    eval q($irq);
    }' unless defined(&__irq_pil);
    eval 'sub __irq_itoa {
        my($irq) = @_;
	    eval q( &BTFIXUP_CALL( &__irq_itoa)($irq));
    }' unless defined(&__irq_itoa);
    eval 'sub NR_IRQS () {16;}' unless defined(&NR_IRQS);
    eval 'sub irq_canonicalize {
        my($irq) = @_;
	    eval q(($irq));
    }' unless defined(&irq_canonicalize);
    eval 'sub disable_irq_nosync {
        my($irq) = @_;
	    eval q({  &BTFIXUP_CALL( &disable_irq)($irq); });
    }' unless defined(&disable_irq_nosync);
    eval 'sub disable_irq {
        my($irq) = @_;
	    eval q({  &BTFIXUP_CALL( &disable_irq)($irq); });
    }' unless defined(&disable_irq);
    eval 'sub enable_irq {
        my($irq) = @_;
	    eval q({  &BTFIXUP_CALL( &enable_irq)($irq); });
    }' unless defined(&enable_irq);
    eval 'sub disable_pil_irq {
        my($irq) = @_;
	    eval q({  &BTFIXUP_CALL( &disable_pil_irq)($irq); });
    }' unless defined(&disable_pil_irq);
    eval 'sub enable_pil_irq {
        my($irq) = @_;
	    eval q({  &BTFIXUP_CALL( &enable_pil_irq)($irq); });
    }' unless defined(&enable_pil_irq);
    eval 'sub clear_clock_irq {
        my($void) = @_;
	    eval q({  &BTFIXUP_CALL( &clear_clock_irq)(); });
    }' unless defined(&clear_clock_irq);
    eval 'sub clear_profile_irq {
        my($irq) = @_;
	    eval q({  &BTFIXUP_CALL( &clear_profile_irq)($irq); });
    }' unless defined(&clear_profile_irq);
    eval 'sub load_profile_irq {
        my($cpu,$limit) = @_;
	    eval q({  &BTFIXUP_CALL( &load_profile_irq)($cpu, $limit); });
    }' unless defined(&load_profile_irq);
    if(defined(&CONFIG_SMP)) {
	eval 'sub set_cpu_int {
	    my($cpu,$level) = @_;
    	    eval q( &BTFIXUP_CALL( &set_cpu_int)($cpu,$level));
	}' unless defined(&set_cpu_int);
	eval 'sub clear_cpu_int {
	    my($cpu,$level) = @_;
    	    eval q( &BTFIXUP_CALL( &clear_cpu_int)($cpu,$level));
	}' unless defined(&clear_cpu_int);
	eval 'sub set_irq_udt {
	    my($cpu) = @_;
    	    eval q( &BTFIXUP_CALL( &set_irq_udt)($cpu));
	}' unless defined(&set_irq_udt);
    }
    eval 'sub SUN4C_INT_ENABLE () {0x1;}' unless defined(&SUN4C_INT_ENABLE);
    eval 'sub SUN4C_INT_E14 () {0x80;}' unless defined(&SUN4C_INT_E14);
    eval 'sub SUN4C_INT_E10 () {0x20;}' unless defined(&SUN4C_INT_E10);
    eval 'sub SUN4C_INT_E8 () {0x10;}' unless defined(&SUN4C_INT_E8);
    eval 'sub SUN4C_INT_E6 () {0x8;}' unless defined(&SUN4C_INT_E6);
    eval 'sub SUN4C_INT_E4 () {0x4;}' unless defined(&SUN4C_INT_E4);
    eval 'sub SUN4C_INT_E1 () {0x2;}' unless defined(&SUN4C_INT_E1);
    eval 'sub SUN4M_INT_ENABLE () {0x80000000;}' unless defined(&SUN4M_INT_ENABLE);
    eval 'sub SUN4M_INT_E14 () {0x80;}' unless defined(&SUN4M_INT_E14);
    eval 'sub SUN4M_INT_E10 () {0x80000;}' unless defined(&SUN4M_INT_E10);
    eval 'sub SUN4M_HARD_INT {
        my($x) = @_;
	    eval q((0x1 << ($x)));
    }' unless defined(&SUN4M_HARD_INT);
    eval 'sub SUN4M_SOFT_INT {
        my($x) = @_;
	    eval q((0x10000 << ($x)));
    }' unless defined(&SUN4M_SOFT_INT);
    eval 'sub SUN4M_INT_MASKALL () {0x80000000;}' unless defined(&SUN4M_INT_MASKALL);
    eval 'sub SUN4M_INT_MODULE_ERR () {0x40000000;}' unless defined(&SUN4M_INT_MODULE_ERR);
    eval 'sub SUN4M_INT_M2S_WRITE () {0x20000000;}' unless defined(&SUN4M_INT_M2S_WRITE);
    eval 'sub SUN4M_INT_ECC () {0x10000000;}' unless defined(&SUN4M_INT_ECC);
    eval 'sub SUN4M_INT_FLOPPY () {0x400000;}' unless defined(&SUN4M_INT_FLOPPY);
    eval 'sub SUN4M_INT_MODULE () {0x200000;}' unless defined(&SUN4M_INT_MODULE);
    eval 'sub SUN4M_INT_VIDEO () {0x100000;}' unless defined(&SUN4M_INT_VIDEO);
    eval 'sub SUN4M_INT_REALTIME () {0x80000;}' unless defined(&SUN4M_INT_REALTIME);
    eval 'sub SUN4M_INT_SCSI () {0x40000;}' unless defined(&SUN4M_INT_SCSI);
    eval 'sub SUN4M_INT_AUDIO () {0x20000;}' unless defined(&SUN4M_INT_AUDIO);
    eval 'sub SUN4M_INT_ETHERNET () {0x10000;}' unless defined(&SUN4M_INT_ETHERNET);
    eval 'sub SUN4M_INT_SERIAL () {0x8000;}' unless defined(&SUN4M_INT_SERIAL);
    eval 'sub SUN4M_INT_KBDMS () {0x4000;}' unless defined(&SUN4M_INT_KBDMS);
    eval 'sub SUN4M_INT_SBUSBITS () {0x3f80;}' unless defined(&SUN4M_INT_SBUSBITS);
    eval 'sub SUN4M_INT_SBUS {
        my($x) = @_;
	    eval q((1<< ($x+7)));
    }' unless defined(&SUN4M_INT_SBUS);
    eval 'sub SUN4M_INT_VME {
        my($x) = @_;
	    eval q((1<< ($x)));
    }' unless defined(&SUN4M_INT_VME);
}
1;
