require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_MOSTEK_H)) {
    eval 'sub _SPARC_MOSTEK_H () {1;}' unless defined(&_SPARC_MOSTEK_H);
    require 'linux/config.ph';
    require 'asm/idprom.ph';
    eval 'sub mostek_read {
        my($_addr) = @_;
	    eval q((*(( &volatile  &u8 *)($_addr))));
    }' unless defined(&mostek_read);
    eval 'sub mostek_write {
        my($_addr,$_val) = @_;
	    eval q(((*(( &volatile  &u8 *)($_addr))) = ($_val)));
    }' unless defined(&mostek_write);
    eval 'sub MOSTEK_EEPROM () {0x;}' unless defined(&MOSTEK_EEPROM);
    eval 'sub MOSTEK_IDPROM () {0x7d8;}' unless defined(&MOSTEK_IDPROM);
    eval 'sub MOSTEK_CREG () {0x7f8;}' unless defined(&MOSTEK_CREG);
    eval 'sub MOSTEK_SEC () {0x7f9;}' unless defined(&MOSTEK_SEC);
    eval 'sub MOSTEK_MIN () {0x7fa;}' unless defined(&MOSTEK_MIN);
    eval 'sub MOSTEK_HOUR () {0x7fb;}' unless defined(&MOSTEK_HOUR);
    eval 'sub MOSTEK_DOW () {0x7fc;}' unless defined(&MOSTEK_DOW);
    eval 'sub MOSTEK_DOM () {0x7fd;}' unless defined(&MOSTEK_DOM);
    eval 'sub MOSTEK_MONTH () {0x7fe;}' unless defined(&MOSTEK_MONTH);
    eval 'sub MOSTEK_YEAR () {0x7ff;}' unless defined(&MOSTEK_YEAR);
    eval 'sub MSTK_CREG_WRITE () {0x80;}' unless defined(&MSTK_CREG_WRITE);
    eval 'sub MSTK_CREG_READ () {0x40;}' unless defined(&MSTK_CREG_READ);
    eval 'sub MSTK_CREG_SIGN () {0x20;}' unless defined(&MSTK_CREG_SIGN);
    eval 'sub MSTK_STOP () {0x80;}' unless defined(&MSTK_STOP);
    eval 'sub MSTK_KICK_START () {0x80;}' unless defined(&MSTK_KICK_START);
    eval 'sub MSTK_FREQ_TEST () {0x40;}' unless defined(&MSTK_FREQ_TEST);
    eval 'sub MSTK_YEAR_ZERO () {1968;}' unless defined(&MSTK_YEAR_ZERO);
    eval 'sub MSTK_CVT_YEAR {
        my($yr) = @_;
	    eval q((($yr) +  &MSTK_YEAR_ZERO));
    }' unless defined(&MSTK_CVT_YEAR);
    eval 'sub MSTK_SEC_MASK () {0x7f;}' unless defined(&MSTK_SEC_MASK);
    eval 'sub MSTK_MIN_MASK () {0x7f;}' unless defined(&MSTK_MIN_MASK);
    eval 'sub MSTK_HOUR_MASK () {0x3f;}' unless defined(&MSTK_HOUR_MASK);
    eval 'sub MSTK_DOW_MASK () {0x7;}' unless defined(&MSTK_DOW_MASK);
    eval 'sub MSTK_DOM_MASK () {0x3f;}' unless defined(&MSTK_DOM_MASK);
    eval 'sub MSTK_MONTH_MASK () {0x1f;}' unless defined(&MSTK_MONTH_MASK);
    eval 'sub MSTK_YEAR_MASK () {0xff;}' unless defined(&MSTK_YEAR_MASK);
    eval 'sub MSTK_REGVAL_TO_DECIMAL {
        my($x) = @_;
	    eval q(((($x) & 0xf) + 0xa * (($x) >> 0x4)));
    }' unless defined(&MSTK_REGVAL_TO_DECIMAL);
    eval 'sub MSTK_DECIMAL_TO_REGVAL {
        my($x) = @_;
	    eval q((((($x) / 0xa) << 0x4) + (($x) % 0xa)));
    }' unless defined(&MSTK_DECIMAL_TO_REGVAL);
    eval 'sub MSTK_GET {
        my($regs,$var,$mask) = @_;
	    eval q(( &MSTK_REGVAL_TO_DECIMAL(($regs)->$var &  &MSTK_  $mask   &_MASK)));
    }' unless defined(&MSTK_GET);
    eval 'sub MSTK_SET {
        my($regs,$var,$value,$mask) = @_;
	    eval q( &do { ($regs)->$var &= ~( &MSTK_  $mask   &_MASK); ($regs)->$var |=  &MSTK_DECIMAL_TO_REGVAL($value) & ( &MSTK_  $mask   &_MASK); }  &while (0));
    }' unless defined(&MSTK_SET);
    eval 'sub MSTK_REG_CREG {
        my($regs) = @_;
	    eval q((($regs)-> &creg));
    }' unless defined(&MSTK_REG_CREG);
    eval 'sub MSTK_REG_SEC {
        my($regs) = @_;
	    eval q( &MSTK_GET($regs, &sec, &SEC));
    }' unless defined(&MSTK_REG_SEC);
    eval 'sub MSTK_REG_MIN {
        my($regs) = @_;
	    eval q( &MSTK_GET($regs, &min, &MIN));
    }' unless defined(&MSTK_REG_MIN);
    eval 'sub MSTK_REG_HOUR {
        my($regs) = @_;
	    eval q( &MSTK_GET($regs, &hour, &HOUR));
    }' unless defined(&MSTK_REG_HOUR);
    eval 'sub MSTK_REG_DOW {
        my($regs) = @_;
	    eval q( &MSTK_GET($regs, &dow, &DOW));
    }' unless defined(&MSTK_REG_DOW);
    eval 'sub MSTK_REG_DOM {
        my($regs) = @_;
	    eval q( &MSTK_GET($regs, &dom, &DOM));
    }' unless defined(&MSTK_REG_DOM);
    eval 'sub MSTK_REG_MONTH {
        my($regs) = @_;
	    eval q( &MSTK_GET($regs, &month, &MONTH));
    }' unless defined(&MSTK_REG_MONTH);
    eval 'sub MSTK_REG_YEAR {
        my($regs) = @_;
	    eval q( &MSTK_GET($regs, &year, &YEAR));
    }' unless defined(&MSTK_REG_YEAR);
    eval 'sub MSTK_SET_REG_SEC {
        my($regs,$value) = @_;
	    eval q( &MSTK_SET($regs, &sec,$value, &SEC));
    }' unless defined(&MSTK_SET_REG_SEC);
    eval 'sub MSTK_SET_REG_MIN {
        my($regs,$value) = @_;
	    eval q( &MSTK_SET($regs, &min,$value, &MIN));
    }' unless defined(&MSTK_SET_REG_MIN);
    eval 'sub MSTK_SET_REG_HOUR {
        my($regs,$value) = @_;
	    eval q( &MSTK_SET($regs, &hour,$value, &HOUR));
    }' unless defined(&MSTK_SET_REG_HOUR);
    eval 'sub MSTK_SET_REG_DOW {
        my($regs,$value) = @_;
	    eval q( &MSTK_SET($regs, &dow,$value, &DOW));
    }' unless defined(&MSTK_SET_REG_DOW);
    eval 'sub MSTK_SET_REG_DOM {
        my($regs,$value) = @_;
	    eval q( &MSTK_SET($regs, &dom,$value, &DOM));
    }' unless defined(&MSTK_SET_REG_DOM);
    eval 'sub MSTK_SET_REG_MONTH {
        my($regs,$value) = @_;
	    eval q( &MSTK_SET($regs, &month,$value, &MONTH));
    }' unless defined(&MSTK_SET_REG_MONTH);
    eval 'sub MSTK_SET_REG_YEAR {
        my($regs,$value) = @_;
	    eval q( &MSTK_SET($regs, &year,$value, &YEAR));
    }' unless defined(&MSTK_SET_REG_YEAR);
    if(defined(&CONFIG_SUN4)) {
	eval("sub MSTK48T02 () { 0; }") unless defined(&MSTK48T02);
	eval("sub MSTK48T08 () { 1; }") unless defined(&MSTK48T08);
	eval("sub INTERSIL () { 2; }") unless defined(&INTERSIL);
	eval("sub MSTK_INVALID () { 3; }") unless defined(&MSTK_INVALID);
    } else {
	eval("sub MSTK48T02 () { 0; }") unless defined(&MSTK48T02);
	eval("sub MSTK48T08 () { 1; }") unless defined(&MSTK48T08);
	eval("sub MSTK_INVALID () { 2; }") unless defined(&MSTK_INVALID);
    }
    if(defined(&CONFIG_SUN4)) {
	eval 'sub INTERSIL_STOP () {0x;}' unless defined(&INTERSIL_STOP);
	eval 'sub INTERSIL_START () {0x8;}' unless defined(&INTERSIL_START);
	eval 'sub INTERSIL_INTR_DISABLE () {0x;}' unless defined(&INTERSIL_INTR_DISABLE);
	eval 'sub INTERSIL_INTR_ENABLE () {0x10;}' unless defined(&INTERSIL_INTR_ENABLE);
	eval 'sub INTERSIL_32K () {0x;}' unless defined(&INTERSIL_32K);
	eval 'sub INTERSIL_NORMAL () {0x;}' unless defined(&INTERSIL_NORMAL);
	eval 'sub INTERSIL_24H () {0x4;}' unless defined(&INTERSIL_24H);
	eval 'sub INTERSIL_INT_100HZ () {0x2;}' unless defined(&INTERSIL_INT_100HZ);
    }
}
1;
