require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_PGTABLE_H)) {
    eval 'sub _SPARC_PGTABLE_H () {1;}' unless defined(&_SPARC_PGTABLE_H);
    require 'linux/config.ph';
    require 'linux/spinlock.ph';
    require 'asm/types.ph';
    if(defined(&CONFIG_SUN4)) {
	require 'asm/pgtsun4.ph';
    } else {
	require 'asm/pgtsun4c.ph';
    }
    require 'asm/pgtsrmmu.ph';
    require 'asm/vac-ops.ph';
    require 'asm/oplib.ph';
    require 'asm/sbus.ph';
    require 'asm/btfixup.ph';
    require 'asm/system.ph';
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub mmu_lockarea {
	    my($vaddr,$len) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_lockarea)($vaddr,$len));
	}' unless defined(&mmu_lockarea);
	eval 'sub mmu_unlockarea {
	    my($vaddr,$len) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_unlockarea)($vaddr,$len));
	}' unless defined(&mmu_unlockarea);
	eval 'sub mmu_get_scsi_one {
	    my($vaddr,$len,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_get_scsi_one)($vaddr,$len,$sbus));
	}' unless defined(&mmu_get_scsi_one);
	eval 'sub mmu_get_scsi_sgl {
	    my($sg,$sz,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_get_scsi_sgl)($sg,$sz,$sbus));
	}' unless defined(&mmu_get_scsi_sgl);
	eval 'sub mmu_release_scsi_one {
	    my($vaddr,$len,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_release_scsi_one)($vaddr,$len,$sbus));
	}' unless defined(&mmu_release_scsi_one);
	eval 'sub mmu_release_scsi_sgl {
	    my($sg,$sz,$sbus) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_release_scsi_sgl)($sg,$sz,$sbus));
	}' unless defined(&mmu_release_scsi_sgl);
	eval 'sub mmu_map_dma_area {
	    my($pba,$va,$a,$len) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_map_dma_area)($pba,$va,$a,$len));
	}' unless defined(&mmu_map_dma_area);
	eval 'sub mmu_unmap_dma_area {
	    my($ba,$len) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_unmap_dma_area)($ba,$len));
	}' unless defined(&mmu_unmap_dma_area);
	eval 'sub mmu_translate_dvma {
	    my($ba) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_translate_dvma)($ba));
	}' unless defined(&mmu_translate_dvma);
	eval 'sub pmd_align {
	    my($addr) = @_;
    	    eval q({ (($addr + ~ &BTFIXUP_SETHI( &pmd_mask)) &  &BTFIXUP_SETHI( &pmd_mask)); });
	}' unless defined(&pmd_align);
	eval 'sub pgdir_align {
	    my($addr) = @_;
    	    eval q({ (($addr + ~ &BTFIXUP_SETHI( &pgdir_mask)) &  &BTFIXUP_SETHI( &pgdir_mask)); });
	}' unless defined(&pgdir_align);
	eval 'sub pte_ERROR {
	    my($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    my($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pmd_ERROR);
	eval 'sub pgd_ERROR {
	    my($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pgd_ERROR);
	eval 'sub PMD_SHIFT () { &BTFIXUP_SIMM13( &pmd_shift);}' unless defined(&PMD_SHIFT);
	eval 'sub PMD_SIZE () { &BTFIXUP_SETHI( &pmd_size);}' unless defined(&PMD_SIZE);
	eval 'sub PMD_MASK () { &BTFIXUP_SETHI( &pmd_mask);}' unless defined(&PMD_MASK);
	eval 'sub PMD_ALIGN {
	    my($addr) = @_;
    	    eval q( &pmd_align($addr));
	}' unless defined(&PMD_ALIGN);
	eval 'sub PGDIR_SHIFT () { &BTFIXUP_SIMM13( &pgdir_shift);}' unless defined(&PGDIR_SHIFT);
	eval 'sub PGDIR_SIZE () { &BTFIXUP_SETHI( &pgdir_size);}' unless defined(&PGDIR_SIZE);
	eval 'sub PGDIR_MASK () { &BTFIXUP_SETHI( &pgdir_mask);}' unless defined(&PGDIR_MASK);
	eval 'sub PGDIR_ALIGN () { &pgdir_align( &addr);}' unless defined(&PGDIR_ALIGN);
	eval 'sub PTRS_PER_PTE () { &BTFIXUP_SIMM13( &ptrs_per_pte);}' unless defined(&PTRS_PER_PTE);
	eval 'sub PTRS_PER_PMD () { &BTFIXUP_SIMM13( &ptrs_per_pmd);}' unless defined(&PTRS_PER_PMD);
	eval 'sub PTRS_PER_PGD () { &BTFIXUP_SIMM13( &ptrs_per_pgd);}' unless defined(&PTRS_PER_PGD);
	eval 'sub USER_PTRS_PER_PGD () { &BTFIXUP_SIMM13( &user_ptrs_per_pgd);}' unless defined(&USER_PTRS_PER_PGD);
	eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
	eval 'sub PAGE_NONE () { &__pgprot( &BTFIXUP_INT( &page_none));}' unless defined(&PAGE_NONE);
	eval 'sub PAGE_SHARED () { &__pgprot( &BTFIXUP_INT( &page_shared));}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_COPY () { &__pgprot( &BTFIXUP_INT( &page_copy));}' unless defined(&PAGE_COPY);
	eval 'sub PAGE_READONLY () { &__pgprot( &BTFIXUP_INT( &page_readonly));}' unless defined(&PAGE_READONLY);
	if(defined(&MODULE)) {
	    eval 'sub PAGE_KERNEL () { &page_kernel;}' unless defined(&PAGE_KERNEL);
	} else {
	    eval 'sub PAGE_KERNEL () { &__pgprot( &BTFIXUP_INT( &page_kernel));}' unless defined(&PAGE_KERNEL);
	}
	eval 'sub __P000 () { &__pgprot(0);}' unless defined(&__P000);
	eval 'sub __P001 () { &__pgprot(0);}' unless defined(&__P001);
	eval 'sub __P010 () { &__pgprot(0);}' unless defined(&__P010);
	eval 'sub __P011 () { &__pgprot(0);}' unless defined(&__P011);
	eval 'sub __P100 () { &__pgprot(0);}' unless defined(&__P100);
	eval 'sub __P101 () { &__pgprot(0);}' unless defined(&__P101);
	eval 'sub __P110 () { &__pgprot(0);}' unless defined(&__P110);
	eval 'sub __P111 () { &__pgprot(0);}' unless defined(&__P111);
	eval 'sub __S000 () { &__pgprot(0);}' unless defined(&__S000);
	eval 'sub __S001 () { &__pgprot(0);}' unless defined(&__S001);
	eval 'sub __S010 () { &__pgprot(0);}' unless defined(&__S010);
	eval 'sub __S011 () { &__pgprot(0);}' unless defined(&__S011);
	eval 'sub __S100 () { &__pgprot(0);}' unless defined(&__S100);
	eval 'sub __S101 () { &__pgprot(0);}' unless defined(&__S101);
	eval 'sub __S110 () { &__pgprot(0);}' unless defined(&__S110);
	eval 'sub __S111 () { &__pgprot(0);}' unless defined(&__S111);
	eval 'sub BAD_PAGETABLE () { &__bad_pagetable();}' unless defined(&BAD_PAGETABLE);
	eval 'sub BAD_PAGE () { &__bad_page();}' unless defined(&BAD_PAGE);
	eval 'sub ZERO_PAGE {
	    my($vaddr) = @_;
    	    eval q(( &virt_to_page( &empty_zero_page)));
	}' unless defined(&ZERO_PAGE);
	eval 'sub pmd_page {
	    my($pmd) = @_;
    	    eval q( &BTFIXUP_CALL( &pmd_page)($pmd));
	}' unless defined(&pmd_page);
	eval 'sub pgd_page {
	    my($pgd) = @_;
    	    eval q( &BTFIXUP_CALL( &pgd_page)($pgd));
	}' unless defined(&pgd_page);
	eval 'sub pte_none {
	    my($pte) = @_;
    	    eval q({ !( &pte_val($pte) & ~ &BTFIXUP_SETHI( &none_mask)); });
	}' unless defined(&pte_none);
	eval 'sub pte_present {
	    my($pte) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_present)($pte));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    my($pte) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_clear)($pte));
	}' unless defined(&pte_clear);
	eval 'sub pmd_none {
	    my($pmd) = @_;
    	    eval q({ !( &pmd_val($pmd) & ~ &BTFIXUP_SETHI( &none_mask)); });
	}' unless defined(&pmd_none);
	eval 'sub pmd_bad {
	    my($pmd) = @_;
    	    eval q( &BTFIXUP_CALL( &pmd_bad)($pmd));
	}' unless defined(&pmd_bad);
	eval 'sub pmd_present {
	    my($pmd) = @_;
    	    eval q( &BTFIXUP_CALL( &pmd_present)($pmd));
	}' unless defined(&pmd_present);
	eval 'sub pmd_clear {
	    my($pmd) = @_;
    	    eval q( &BTFIXUP_CALL( &pmd_clear)($pmd));
	}' unless defined(&pmd_clear);
	eval 'sub pgd_none {
	    my($pgd) = @_;
    	    eval q( &BTFIXUP_CALL( &pgd_none)($pgd));
	}' unless defined(&pgd_none);
	eval 'sub pgd_bad {
	    my($pgd) = @_;
    	    eval q( &BTFIXUP_CALL( &pgd_bad)($pgd));
	}' unless defined(&pgd_bad);
	eval 'sub pgd_present {
	    my($pgd) = @_;
    	    eval q( &BTFIXUP_CALL( &pgd_present)($pgd));
	}' unless defined(&pgd_present);
	eval 'sub pgd_clear {
	    my($pgd) = @_;
    	    eval q( &BTFIXUP_CALL( &pgd_clear)($pgd));
	}' unless defined(&pgd_clear);
	eval 'sub pte_write {
	    my($pte) = @_;
    	    eval q({  &pte_val($pte) &  &BTFIXUP_HALF( &pte_writei); });
	}' unless defined(&pte_write);
	eval 'sub pte_dirty {
	    my($pte) = @_;
    	    eval q({  &pte_val($pte) &  &BTFIXUP_HALF( &pte_dirtyi); });
	}' unless defined(&pte_dirty);
	eval 'sub pte_young {
	    my($pte) = @_;
    	    eval q({  &pte_val($pte) &  &BTFIXUP_HALF( &pte_youngi); });
	}' unless defined(&pte_young);
	eval 'sub pte_file {
	    my($pte) = @_;
    	    eval q({  &pte_val($pte) &  &BTFIXUP_HALF( &pte_filei); });
	}' unless defined(&pte_file);
	eval 'sub pte_wrprotect {
	    my($pte) = @_;
    	    eval q({  &__pte( &pte_val($pte) & ~ &BTFIXUP_HALF( &pte_wrprotecti)); });
	}' unless defined(&pte_wrprotect);
	eval 'sub pte_mkclean {
	    my($pte) = @_;
    	    eval q({  &__pte( &pte_val($pte) & ~ &BTFIXUP_HALF( &pte_mkcleani)); });
	}' unless defined(&pte_mkclean);
	eval 'sub pte_mkold {
	    my($pte) = @_;
    	    eval q({  &__pte( &pte_val($pte) & ~ &BTFIXUP_HALF( &pte_mkoldi)); });
	}' unless defined(&pte_mkold);
	eval 'sub pte_mkwrite {
	    my($pte) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_mkwrite)($pte));
	}' unless defined(&pte_mkwrite);
	eval 'sub pte_mkdirty {
	    my($pte) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_mkdirty)($pte));
	}' unless defined(&pte_mkdirty);
	eval 'sub pte_mkyoung {
	    my($pte) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_mkyoung)($pte));
	}' unless defined(&pte_mkyoung);
	eval 'sub page_pte_prot {
	    my($page, $prot) = @_;
    	    eval q( &mk_pte($page, $prot));
	}' unless defined(&page_pte_prot);
	eval 'sub page_pte {
	    my($page) = @_;
    	    eval q( &mk_pte($page,  &__pgprot(0)));
	}' unless defined(&page_pte);
	eval 'sub pfn_pte {
	    my($pfn, $prot) = @_;
    	    eval q( &mk_pte( &pfn_to_page($pfn), $prot));
	}' unless defined(&pfn_pte);
	eval 'sub pte_pfn {
	    my($pte) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_pfn)($pte));
	}' unless defined(&pte_pfn);
	eval 'sub pte_page {
	    my($pte) = @_;
    	    eval q( &pfn_to_page( &pte_pfn($pte)));
	}' unless defined(&pte_page);
	eval 'sub mk_pte {
	    my($page,$pgprot) = @_;
    	    eval q( &BTFIXUP_CALL( &mk_pte)($page,$pgprot));
	}' unless defined(&mk_pte);
	eval 'sub mk_pte_phys {
	    my($page,$pgprot) = @_;
    	    eval q( &BTFIXUP_CALL( &mk_pte_phys)($page,$pgprot));
	}' unless defined(&mk_pte_phys);
	eval 'sub mk_pte_io {
	    my($page,$pgprot,$space) = @_;
    	    eval q( &BTFIXUP_CALL( &mk_pte_io)($page,$pgprot,$space));
	}' unless defined(&mk_pte_io);
	eval 'sub pte_modify {
	    my($pte,$newprot) = @_;
    	    eval q({  &__pte(( &pte_val($pte) &  &BTFIXUP_INT( &pte_modify_mask)) |  &pgprot_val($newprot)); });
	}' unless defined(&pte_modify);
	eval 'sub pgd_index {
	    my($address) = @_;
    	    eval q((($address) >>  &PGDIR_SHIFT));
	}' unless defined(&pgd_index);
	eval 'sub pgd_offset {
	    my($mm, $address) = @_;
    	    eval q((($mm)-> &pgd +  &pgd_index($address)));
	}' unless defined(&pgd_offset);
	eval 'sub pgd_offset_k {
	    my($address) = @_;
    	    eval q( &pgd_offset( &init_mm, $address));
	}' unless defined(&pgd_offset_k);
	eval 'sub pmd_offset {
	    my($dir,$addr) = @_;
    	    eval q( &BTFIXUP_CALL( &pmd_offset)($dir,$addr));
	}' unless defined(&pmd_offset);
	eval 'sub pte_offset_kernel {
	    my($dir,$addr) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_offset_kernel)($dir,$addr));
	}' unless defined(&pte_offset_kernel);
	eval 'sub pte_offset_map {
	    my($d, $a) = @_;
    	    eval q( &pte_offset_kernel($d,$a));
	}' unless defined(&pte_offset_map);
	eval 'sub pte_offset_map_nested {
	    my($d, $a) = @_;
    	    eval q( &pte_offset_kernel($d,$a));
	}' unless defined(&pte_offset_map_nested);
	eval 'sub pte_unmap {
	    my($pte) = @_;
    	    eval q( &do{} &while(0));
	}' unless defined(&pte_unmap);
	eval 'sub pte_unmap_nested {
	    my($pte) = @_;
    	    eval q( &do{} &while(0));
	}' unless defined(&pte_unmap_nested);
	eval 'sub set_pte {
	    my($ptep,$pteval) = @_;
    	    eval q( &BTFIXUP_CALL( &set_pte)($ptep,$pteval));
	}' unless defined(&set_pte);
	eval 'sub mmu_info {
	    my($p) = @_;
    	    eval q( &BTFIXUP_CALL( &mmu_info)($p));
	}' unless defined(&mmu_info);
	eval 'sub FAULT_CODE_PROT () {0x1;}' unless defined(&FAULT_CODE_PROT);
	eval 'sub FAULT_CODE_WRITE () {0x2;}' unless defined(&FAULT_CODE_WRITE);
	eval 'sub FAULT_CODE_USER () {0x4;}' unless defined(&FAULT_CODE_USER);
	eval 'sub update_mmu_cache {
	    my($vma,$addr,$pte) = @_;
    	    eval q( &BTFIXUP_CALL( &update_mmu_cache)($vma,$addr,$pte));
	}' unless defined(&update_mmu_cache);
	eval 'sub sparc_mapiorange {
	    my($bus,$pa,$va,$len) = @_;
    	    eval q( &BTFIXUP_CALL( &sparc_mapiorange)($bus,$pa,$va,$len));
	}' unless defined(&sparc_mapiorange);
	eval 'sub sparc_unmapiorange {
	    my($va,$len) = @_;
    	    eval q( &BTFIXUP_CALL( &sparc_unmapiorange)($va,$len));
	}' unless defined(&sparc_unmapiorange);
	eval 'sub __swp_type {
	    my($x) = @_;
    	    eval q(((($x). &val >> 2) & 0x7f));
	}' unless defined(&__swp_type);
	eval 'sub __swp_offset {
	    my($x) = @_;
    	    eval q(((($x). &val >> 9) & 0x3ffff));
	}' unless defined(&__swp_offset);
	eval 'sub __swp_entry {
	    my($type,$offset) = @_;
    	    eval q((( &swp_entry_t) { ((($type) & 0x7f) << 2) | ((($offset) & 0x3ffff) << 9) }));
	}' unless defined(&__swp_entry);
	eval 'sub __pte_to_swp_entry {
	    my($pte) = @_;
    	    eval q((( &swp_entry_t) {  &pte_val($pte) }));
	}' unless defined(&__pte_to_swp_entry);
	eval 'sub __swp_entry_to_pte {
	    my($x) = @_;
    	    eval q((( &pte_t) { ($x). &val }));
	}' unless defined(&__swp_entry_to_pte);
	eval 'sub pte_to_pgoff {
	    my($pte) = @_;
    	    eval q( &BTFIXUP_CALL( &pte_to_pgoff)($pte));
	}' unless defined(&pte_to_pgoff);
	eval 'sub pgoff_to_pte {
	    my($off) = @_;
    	    eval q( &BTFIXUP_CALL( &pgoff_to_pte)($off));
	}' unless defined(&pgoff_to_pte);
	eval 'sub PTE_FILE_MAX_BITS () {24;}' unless defined(&PTE_FILE_MAX_BITS);
	eval 'sub NO_CONTEXT () {-1;}' unless defined(&NO_CONTEXT);
	eval 'sub remove_from_ctx_list {
	    my($entry) = @_;
    	    eval q({  ($entry->{next}->{prev}) =  ($entry->{prev});  ($entry->{prev}->{next}) =  ($entry->{next}); });
	}' unless defined(&remove_from_ctx_list);
	eval 'sub add_to_ctx_list {
	    my($head,$entry) = @_;
    	    eval q({  ($entry->{next}) = $head; ( ($entry->{prev}) =  ($head->{prev}))-> &next = $entry;  ($head->{prev}) = $entry; });
	}' unless defined(&add_to_ctx_list);
	eval 'sub add_to_free_ctxlist {
	    my($entry) = @_;
    	    eval q( &add_to_ctx_list( &ctx_free, $entry));
	}' unless defined(&add_to_free_ctxlist);
	eval 'sub add_to_used_ctxlist {
	    my($entry) = @_;
    	    eval q( &add_to_ctx_list( &ctx_used, $entry));
	}' unless defined(&add_to_used_ctxlist);
	eval 'sub __get_phys {
	    my($addr) = @_;
    	    eval q({  &switch ( &sparc_cpu_model){  &case  &sun4:  &case  &sun4c:  &sun4c_get_pte ($addr) <<  &PAGE_SHIFT;  &case  &sun4m:  &case  &sun4d: (( &srmmu_get_pte ($addr) & 0xffffff00) << 4);  &default: 0; } });
	}' unless defined(&__get_phys);
	eval 'sub __get_iospace {
	    my($addr) = @_;
    	    eval q({  &switch ( &sparc_cpu_model){  &case  &sun4:  &case  &sun4c: -1;  &case  &sun4m:  &case  &sun4d: ( &srmmu_get_pte ($addr) >> 28);  &default: -1; } });
	}' unless defined(&__get_iospace);
	eval 'sub kern_addr_valid {
	    my($addr) = @_;
    	    eval q(( &test_bit( &__pa(($addr))>>20,  &sparc_valid_addr_bitmap)));
	}' unless defined(&kern_addr_valid);
	require 'asm-generic/pgtable.ph';
    }
    eval 'sub HAVE_ARCH_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_UNMAPPED_AREA);
    eval 'sub pgtable_cache_init () {
        eval q( &do { }  &while (0));
    }' unless defined(&pgtable_cache_init);
}
1;
