require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_WINMACRO_H)) {
    eval 'sub _SPARC_WINMACRO_H () {1;}' unless defined(&_SPARC_WINMACRO_H);
    require 'linux/config.ph';
    require 'asm/ptrace.ph';
    eval 'sub STORE_WINDOW {
        my($reg) = @_;
	    eval q( &std % &l0, [%$reg +  &RW_L0];  &std % &l2, [%$reg +  &RW_L2];  &std % &l4, [%$reg +  &RW_L4];  &std % &l6, [%$reg +  &RW_L6];  &std % &i0, [%$reg +  &RW_I0];  &std % &i2, [%$reg +  &RW_I2];  &std % &i4, [%$reg +  &RW_I4];  &std % &i6, [%$reg +  &RW_I6];);
    }' unless defined(&STORE_WINDOW);
    eval 'sub LOAD_WINDOW {
        my($reg) = @_;
	    eval q( &ldd [%$reg +  &RW_L0], % &l0;  &ldd [%$reg +  &RW_L2], % &l2;  &ldd [%$reg +  &RW_L4], % &l4;  &ldd [%$reg +  &RW_L6], % &l6;  &ldd [%$reg +  &RW_I0], % &i0;  &ldd [%$reg +  &RW_I2], % &i2;  &ldd [%$reg +  &RW_I4], % &i4;  &ldd [%$reg +  &RW_I6], % &i6;);
    }' unless defined(&LOAD_WINDOW);
    eval 'sub LOAD_PT_INS {
        my($base_reg) = @_;
	    eval q( &ldd [%$base_reg +  &STACKFRAME_SZ +  &PT_I0], % &i0;  &ldd [%$base_reg +  &STACKFRAME_SZ +  &PT_I2], % &i2;  &ldd [%$base_reg +  &STACKFRAME_SZ +  &PT_I4], % &i4;  &ldd [%$base_reg +  &STACKFRAME_SZ +  &PT_I6], % &i6;);
    }' unless defined(&LOAD_PT_INS);
    eval 'sub LOAD_PT_GLOBALS {
        my($base_reg) = @_;
	    eval q( &ld [%$base_reg +  &STACKFRAME_SZ +  &PT_G1], % &g1;  &ldd [%$base_reg +  &STACKFRAME_SZ +  &PT_G2], % &g2;  &ldd [%$base_reg +  &STACKFRAME_SZ +  &PT_G4], % &g4;  &ldd [%$base_reg +  &STACKFRAME_SZ +  &PT_G6], % &g6;);
    }' unless defined(&LOAD_PT_GLOBALS);
    eval 'sub LOAD_PT_YREG {
        my($base_reg, $scratch) = @_;
	    eval q( &ld [%$base_reg +  &STACKFRAME_SZ +  &PT_Y], %$scratch;  &wr %$scratch, 0x, % &y;);
    }' unless defined(&LOAD_PT_YREG);
    eval 'sub LOAD_PT_PRIV {
        my($base_reg, $pt_psr, $pt_pc, $pt_npc) = @_;
	    eval q( &ld [%$base_reg +  &STACKFRAME_SZ +  &PT_PSR], %$pt_psr;  &ld [%$base_reg +  &STACKFRAME_SZ +  &PT_PC], %$pt_pc;  &ld [%$base_reg +  &STACKFRAME_SZ +  &PT_NPC], %$pt_npc;);
    }' unless defined(&LOAD_PT_PRIV);
    eval 'sub LOAD_PT_ALL {
        my($base_reg, $pt_psr, $pt_pc, $pt_npc, $scratch) = @_;
	    eval q( &LOAD_PT_YREG($base_reg, $scratch)  &LOAD_PT_INS($base_reg)  &LOAD_PT_GLOBALS($base_reg)  &LOAD_PT_PRIV($base_reg, $pt_psr, $pt_pc, $pt_npc));
    }' unless defined(&LOAD_PT_ALL);
    eval 'sub STORE_PT_INS {
        my($base_reg) = @_;
	    eval q( &std % &i0, [%$base_reg +  &STACKFRAME_SZ +  &PT_I0];  &std % &i2, [%$base_reg +  &STACKFRAME_SZ +  &PT_I2];  &std % &i4, [%$base_reg +  &STACKFRAME_SZ +  &PT_I4];  &std % &i6, [%$base_reg +  &STACKFRAME_SZ +  &PT_I6];);
    }' unless defined(&STORE_PT_INS);
    eval 'sub STORE_PT_GLOBALS {
        my($base_reg) = @_;
	    eval q( &st % &g1, [%$base_reg +  &STACKFRAME_SZ +  &PT_G1];  &std % &g2, [%$base_reg +  &STACKFRAME_SZ +  &PT_G2];  &std % &g4, [%$base_reg +  &STACKFRAME_SZ +  &PT_G4];  &std % &g6, [%$base_reg +  &STACKFRAME_SZ +  &PT_G6];);
    }' unless defined(&STORE_PT_GLOBALS);
    eval 'sub STORE_PT_YREG {
        my($base_reg, $scratch) = @_;
	    eval q( &rd % &y, %$scratch;  &st %$scratch, [%$base_reg +  &STACKFRAME_SZ +  &PT_Y];);
    }' unless defined(&STORE_PT_YREG);
    eval 'sub STORE_PT_PRIV {
        my($base_reg, $pt_psr, $pt_pc, $pt_npc) = @_;
	    eval q( &st %$pt_psr, [%$base_reg +  &STACKFRAME_SZ +  &PT_PSR];  &st %$pt_pc, [%$base_reg +  &STACKFRAME_SZ +  &PT_PC];  &st %$pt_npc, [%$base_reg +  &STACKFRAME_SZ +  &PT_NPC];);
    }' unless defined(&STORE_PT_PRIV);
    eval 'sub STORE_PT_ALL {
        my($base_reg, $reg_psr, $reg_pc, $reg_npc, $g_scratch) = @_;
	    eval q( &STORE_PT_PRIV($base_reg, $reg_psr, $reg_pc, $reg_npc)  &STORE_PT_GLOBALS($base_reg)  &STORE_PT_YREG($base_reg, $g_scratch)  &STORE_PT_INS($base_reg));
    }' unless defined(&STORE_PT_ALL);
    eval 'sub SAVE_BOLIXED_USER_STACK {
        my($cur_reg, $scratch) = @_;
	    eval q( &ld [%$cur_reg +  &TI_W_SAVED], %$scratch;  &sll %$scratch, 2, %$scratch;  &add %$scratch, %$cur_reg, %$scratch;  &st % &sp, [%$scratch +  &TI_RWIN_SPTRS];  &sub %$scratch, %$cur_reg, %$scratch;  &sll %$scratch, 4, %$scratch;  &add %$scratch, %$cur_reg, %$scratch;  &STORE_WINDOW($scratch +  &TI_REG_WINDOW);  &sub %$scratch, %$cur_reg, %$scratch;  &srl %$scratch, 6, %$scratch;  &add %$scratch, 1, %$scratch;  &st %$scratch, [%$cur_reg +  &TI_W_SAVED];);
    }' unless defined(&SAVE_BOLIXED_USER_STACK);
    if(defined(&CONFIG_SMP)) {
	eval 'sub LOAD_CURRENT4M {
	    my($dest_reg, $idreg) = @_;
    	    eval q( &rd % &tbr, %$idreg;  &sethi % &hi( &current_set), %$dest_reg;  &srl %$idreg, 10, %$idreg;  &or %$dest_reg, % &lo( &current_set), %$dest_reg;  &and %$idreg, 0xc, %$idreg;  &ld [%$idreg + %$dest_reg], %$dest_reg;);
	}' unless defined(&LOAD_CURRENT4M);
	eval 'sub LOAD_CURRENT4D {
	    my($dest_reg) = @_;
    	    eval q( &lda [% &g0]  &ASI_M_VIKING_TMP2, %$dest_reg;);
	}' unless defined(&LOAD_CURRENT4D);
	eval 'sub LOAD_CURRENT {
	    my($dest_reg, $idreg) = @_;
    	    eval q( &sethi % &hi( &___b_load_current), %$idreg;  &sethi % &hi( &current_set), %$dest_reg;  &sethi % &hi( &boot_cpu_id4), %$idreg;  &or %$dest_reg, % &lo( &current_set), %$dest_reg;  &ldub [%$idreg + % &lo( &boot_cpu_id4)], %$idreg;  &ld [%$idreg + %$dest_reg], %$dest_reg;);
	}' unless defined(&LOAD_CURRENT);
    } else {
	eval 'sub LOAD_CURRENT {
	    my($dest_reg, $idreg) = @_;
    	    eval q( &sethi % &hi( &current_set), %$idreg;  &ld [%$idreg + % &lo( &current_set)], %$dest_reg;);
	}' unless defined(&LOAD_CURRENT);
    }
}
1;
