require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SPARC64_DMA_H)) {
    eval 'sub _ASM_SPARC64_DMA_H () {1;}' unless defined(&_ASM_SPARC64_DMA_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'linux/spinlock.ph';
    require 'asm/sbus.ph';
    require 'asm/delay.ph';
    require 'asm/oplib.ph';
    eval 'sub claim_dma_lock () {
        eval q(({ \'unsigned long flags\';  &spin_lock_irqsave( &dma_spin_lock,  &flags);  &flags; }));
    }' unless defined(&claim_dma_lock);
    eval 'sub release_dma_lock {
        my($__flags) = @_;
	    eval q( &spin_unlock_irqrestore( &dma_spin_lock, $__flags););
    }' unless defined(&release_dma_lock);
    eval 'sub MAX_DMA_CHANNELS () {8;}' unless defined(&MAX_DMA_CHANNELS);
    eval 'sub DMA_MODE_READ () {1;}' unless defined(&DMA_MODE_READ);
    eval 'sub DMA_MODE_WRITE () {2;}' unless defined(&DMA_MODE_WRITE);
    eval 'sub MAX_DMA_ADDRESS () {(~0);}' unless defined(&MAX_DMA_ADDRESS);
    eval 'sub SIZE_16MB () {(16*1024*1024);}' unless defined(&SIZE_16MB);
    eval 'sub SIZE_64K () {(64*1024);}' unless defined(&SIZE_64K);
    eval 'sub DMA_CSR () {0x;}' unless defined(&DMA_CSR);
    eval 'sub DMA_ADDR () {0x4;}' unless defined(&DMA_ADDR);
    eval 'sub DMA_COUNT () {0x8;}' unless defined(&DMA_COUNT);
    eval 'sub DMA_TEST () {0xc;}' unless defined(&DMA_TEST);
    eval("sub dvmarev0 () { 0; }") unless defined(&dvmarev0);
    eval("sub dvmaesc1 () { 1; }") unless defined(&dvmaesc1);
    eval("sub dvmarev1 () { 2; }") unless defined(&dvmarev1);
    eval("sub dvmarev2 () { 3; }") unless defined(&dvmarev2);
    eval("sub dvmarev3 () { 4; }") unless defined(&dvmarev3);
    eval("sub dvmarevplus () { 5; }") unless defined(&dvmarevplus);
    eval("sub dvmahme () { 6; }") unless defined(&dvmahme);
    eval 'sub DMA_HASCOUNT {
        my($rev) = @_;
	    eval q((($rev)== &dvmaesc1));
    }' unless defined(&DMA_HASCOUNT);
    eval 'sub DMA_ISBROKEN {
        my($dma) = @_;
	    eval q((($dma)-> &revision ==  &dvmarev1));
    }' unless defined(&DMA_ISBROKEN);
    eval 'sub DMA_ISESC1 {
        my($dma) = @_;
	    eval q((($dma)-> &revision ==  &dvmaesc1));
    }' unless defined(&DMA_ISESC1);
    eval 'sub DMA_DEVICE_ID () {0xf0000000;}' unless defined(&DMA_DEVICE_ID);
    eval 'sub DMA_VERS0 () {0x;}' unless defined(&DMA_VERS0);
    eval 'sub DMA_ESCV1 () {0x40000000;}' unless defined(&DMA_ESCV1);
    eval 'sub DMA_VERS1 () {0x80000000;}' unless defined(&DMA_VERS1);
    eval 'sub DMA_VERS2 () {0xa0000000;}' unless defined(&DMA_VERS2);
    eval 'sub DMA_VERHME () {0xb0000000;}' unless defined(&DMA_VERHME);
    eval 'sub DMA_VERSPLUS () {0x90000000;}' unless defined(&DMA_VERSPLUS);
    eval 'sub DMA_HNDL_INTR () {0x1;}' unless defined(&DMA_HNDL_INTR);
    eval 'sub DMA_HNDL_ERROR () {0x2;}' unless defined(&DMA_HNDL_ERROR);
    eval 'sub DMA_FIFO_ISDRAIN () {0xc;}' unless defined(&DMA_FIFO_ISDRAIN);
    eval 'sub DMA_INT_ENAB () {0x10;}' unless defined(&DMA_INT_ENAB);
    eval 'sub DMA_FIFO_INV () {0x20;}' unless defined(&DMA_FIFO_INV);
    eval 'sub DMA_ACC_SZ_ERR () {0x40;}' unless defined(&DMA_ACC_SZ_ERR);
    eval 'sub DMA_FIFO_STDRAIN () {0x40;}' unless defined(&DMA_FIFO_STDRAIN);
    eval 'sub DMA_RST_SCSI () {0x80;}' unless defined(&DMA_RST_SCSI);
    eval 'sub DMA_RST_ENET () { &DMA_RST_SCSI;}' unless defined(&DMA_RST_ENET);
    eval 'sub DMA_ST_WRITE () {0x100;}' unless defined(&DMA_ST_WRITE);
    eval 'sub DMA_ENABLE () {0x200;}' unless defined(&DMA_ENABLE);
    eval 'sub DMA_PEND_READ () {0x400;}' unless defined(&DMA_PEND_READ);
    eval 'sub DMA_ESC_BURST () {0x800;}' unless defined(&DMA_ESC_BURST);
    eval 'sub DMA_READ_AHEAD () {0x1800;}' unless defined(&DMA_READ_AHEAD);
    eval 'sub DMA_DSBL_RD_DRN () {0x1000;}' unless defined(&DMA_DSBL_RD_DRN);
    eval 'sub DMA_BCNT_ENAB () {0x2000;}' unless defined(&DMA_BCNT_ENAB);
    eval 'sub DMA_TERM_CNTR () {0x4000;}' unless defined(&DMA_TERM_CNTR);
    eval 'sub DMA_SCSI_SBUS64 () {0x8000;}' unless defined(&DMA_SCSI_SBUS64);
    eval 'sub DMA_CSR_DISAB () {0x10000;}' unless defined(&DMA_CSR_DISAB);
    eval 'sub DMA_SCSI_DISAB () {0x20000;}' unless defined(&DMA_SCSI_DISAB);
    eval 'sub DMA_DSBL_WR_INV () {0x20000;}' unless defined(&DMA_DSBL_WR_INV);
    eval 'sub DMA_ADD_ENABLE () {0x40000;}' unless defined(&DMA_ADD_ENABLE);
    eval 'sub DMA_E_BURSTS () {0xc0000;}' unless defined(&DMA_E_BURSTS);
    eval 'sub DMA_E_BURST32 () {0x40000;}' unless defined(&DMA_E_BURST32);
    eval 'sub DMA_E_BURST16 () {0x;}' unless defined(&DMA_E_BURST16);
    eval 'sub DMA_BRST_SZ () {0xc0000;}' unless defined(&DMA_BRST_SZ);
    eval 'sub DMA_BRST64 () {0xc0000;}' unless defined(&DMA_BRST64);
    eval 'sub DMA_BRST32 () {0x40000;}' unless defined(&DMA_BRST32);
    eval 'sub DMA_BRST16 () {0x;}' unless defined(&DMA_BRST16);
    eval 'sub DMA_BRST0 () {0x80000;}' unless defined(&DMA_BRST0);
    eval 'sub DMA_ADDR_DISAB () {0x100000;}' unless defined(&DMA_ADDR_DISAB);
    eval 'sub DMA_2CLKS () {0x200000;}' unless defined(&DMA_2CLKS);
    eval 'sub DMA_3CLKS () {0x400000;}' unless defined(&DMA_3CLKS);
    eval 'sub DMA_EN_ENETAUI () { &DMA_3CLKS;}' unless defined(&DMA_EN_ENETAUI);
    eval 'sub DMA_CNTR_DISAB () {0x800000;}' unless defined(&DMA_CNTR_DISAB);
    eval 'sub DMA_AUTO_NADDR () {0x1000000;}' unless defined(&DMA_AUTO_NADDR);
    eval 'sub DMA_SCSI_ON () {0x2000000;}' unless defined(&DMA_SCSI_ON);
    eval 'sub DMA_PARITY_OFF () {0x2000000;}' unless defined(&DMA_PARITY_OFF);
    eval 'sub DMA_LOADED_ADDR () {0x4000000;}' unless defined(&DMA_LOADED_ADDR);
    eval 'sub DMA_LOADED_NADDR () {0x8000000;}' unless defined(&DMA_LOADED_NADDR);
    eval 'sub DMA_RESET_FAS366 () {0x8000000;}' unless defined(&DMA_RESET_FAS366);
    eval 'sub DMA_BURST1 () {0x1;}' unless defined(&DMA_BURST1);
    eval 'sub DMA_BURST2 () {0x2;}' unless defined(&DMA_BURST2);
    eval 'sub DMA_BURST4 () {0x4;}' unless defined(&DMA_BURST4);
    eval 'sub DMA_BURST8 () {0x8;}' unless defined(&DMA_BURST8);
    eval 'sub DMA_BURST16 () {0x10;}' unless defined(&DMA_BURST16);
    eval 'sub DMA_BURST32 () {0x20;}' unless defined(&DMA_BURST32);
    eval 'sub DMA_BURST64 () {0x40;}' unless defined(&DMA_BURST64);
    eval 'sub DMA_BURSTBITS () {0x7f;}' unless defined(&DMA_BURSTBITS);
    eval 'sub DMA_MAXEND {
        my($addr) = @_;
	    eval q((0x1000000-((($addr))&0xffffff)));
    }' unless defined(&DMA_MAXEND);
    eval 'sub DMA_ERROR_P {
        my($regs) = @_;
	    eval q(((( &sbus_readl(($regs) +  &DMA_CSR) &  &DMA_HNDL_ERROR)));
    }' unless defined(&DMA_ERROR_P);
    eval 'sub DMA_IRQ_P {
        my($regs) = @_;
	    eval q(((( &sbus_readl(($regs) +  &DMA_CSR)) & ( &DMA_HNDL_INTR |  &DMA_HNDL_ERROR))));
    }' unless defined(&DMA_IRQ_P);
    eval 'sub DMA_WRITE_P {
        my($regs) = @_;
	    eval q(((( &sbus_readl(($regs) +  &DMA_CSR) &  &DMA_ST_WRITE)));
    }' unless defined(&DMA_WRITE_P);
    eval 'sub DMA_OFF {
        my($__regs) = @_;
	    eval q( &do {  &u32  &tmp =  &sbus_readl(($__regs) +  &DMA_CSR);  &tmp &= ~ &DMA_ENABLE;  &sbus_writel( &tmp, ($__regs) +  &DMA_CSR); }  &while(0));
    }' unless defined(&DMA_OFF);
    eval 'sub DMA_INTSOFF {
        my($__regs) = @_;
	    eval q( &do {  &u32  &tmp =  &sbus_readl(($__regs) +  &DMA_CSR);  &tmp &= ~ &DMA_INT_ENAB;  &sbus_writel( &tmp, ($__regs) +  &DMA_CSR); }  &while(0));
    }' unless defined(&DMA_INTSOFF);
    eval 'sub DMA_INTSON {
        my($__regs) = @_;
	    eval q( &do {  &u32  &tmp =  &sbus_readl(($__regs) +  &DMA_CSR);  &tmp |=  &DMA_INT_ENAB;  &sbus_writel( &tmp, ($__regs) +  &DMA_CSR); }  &while(0));
    }' unless defined(&DMA_INTSON);
    eval 'sub DMA_PUNTFIFO {
        my($__regs) = @_;
	    eval q( &do {  &u32  &tmp =  &sbus_readl(($__regs) +  &DMA_CSR);  &tmp |=  &DMA_FIFO_INV;  &sbus_writel( &tmp, ($__regs) +  &DMA_CSR); }  &while(0));
    }' unless defined(&DMA_PUNTFIFO);
    eval 'sub DMA_SETSTART {
        my($__regs, $__addr) = @_;
	    eval q( &sbus_writel(( &u32)($__addr), ($__regs) +  &DMA_ADDR););
    }' unless defined(&DMA_SETSTART);
    eval 'sub DMA_BEGINDMA_W {
        my($__regs) = @_;
	    eval q( &do {  &u32  &tmp =  &sbus_readl(($__regs) +  &DMA_CSR);  &tmp |= ( &DMA_ST_WRITE| &DMA_ENABLE| &DMA_INT_ENAB);  &sbus_writel( &tmp, ($__regs) +  &DMA_CSR); }  &while(0));
    }' unless defined(&DMA_BEGINDMA_W);
    eval 'sub DMA_BEGINDMA_R {
        my($__regs) = @_;
	    eval q( &do {  &u32  &tmp =  &sbus_readl(($__regs) +  &DMA_CSR);  &tmp |= ( &DMA_ENABLE| &DMA_INT_ENAB);  &tmp &= ~ &DMA_ST_WRITE;  &sbus_writel( &tmp, ($__regs) +  &DMA_CSR); }  &while(0));
    }' unless defined(&DMA_BEGINDMA_R);
    eval 'sub DMA_IRQ_ENTRY {
        my($dma, $dregs) = @_;
	    eval q( &do {  &if( &DMA_ISBROKEN($dma))  &DMA_INTSOFF($dregs); }  &while (0));
    }' unless defined(&DMA_IRQ_ENTRY);
    eval 'sub DMA_IRQ_EXIT {
        my($dma, $dregs) = @_;
	    eval q( &do {  &if( &DMA_ISBROKEN($dma))  &DMA_INTSON($dregs); }  &while(0));
    }' unless defined(&DMA_IRQ_EXIT);
    eval 'sub for_each_dvma {
        my($dma) = @_;
	    eval q( &for(($dma) =  &dma_chain; ($dma); ($dma) = ($dma)-> &next));
    }' unless defined(&for_each_dvma);
    if(defined(&CONFIG_PCI)) {
    } else {
	eval 'sub isa_dma_bridge_buggy () {(0);}' unless defined(&isa_dma_bridge_buggy);
    }
}
1;
