require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_IDE_H)) {
    eval 'sub _SPARC64_IDE_H () {1;}' unless defined(&_SPARC64_IDE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'asm/pgalloc.ph';
	require 'asm/io.ph';
	require 'asm/hdreg.ph';
	require 'asm/page.ph';
	require 'asm/spitfire.ph';
	unless(defined(&MAX_HWIFS)) {
	    if(defined(&CONFIG_BLK_DEV_IDEPCI)) {
		eval 'sub MAX_HWIFS () {10;}' unless defined(&MAX_HWIFS);
	    } else {
		eval 'sub MAX_HWIFS () {2;}' unless defined(&MAX_HWIFS);
	    }
	}
	eval 'sub ide_default_irq {
	    my($base) = @_;
    	    eval q({ 0; });
	}' unless defined(&ide_default_irq);
	eval 'sub ide_default_io_base {
	    my($index) = @_;
    	    eval q({ 0; });
	}' unless defined(&ide_default_io_base);
	eval 'sub ide_init_hwif_ports {
	    my($hw,$data_port,$ctrl_port,$irq) = @_;
    	    eval q({ my $reg = $data_port; \'int\'  &i;  &for ( &i =  &IDE_DATA_OFFSET;  &i <=  &IDE_STATUS_OFFSET;  &i++) {  ($hw->{io_ports[&i]}) =  $reg;  $reg += 1; }  &if ($ctrl_port) {  ($hw->{io_ports[&IDE_CONTROL_OFFSET]}) = $ctrl_port; }  &else {  ($hw->{io_ports[&IDE_CONTROL_OFFSET]}) =  ($hw->{io_ports[&IDE_DATA_OFFSET]}) + 0x206; }  &if ($irq !=  &NULL) *$irq = 0;  ($hw->{io_ports[&IDE_IRQ_OFFSET]}) = 0; });
	}' unless defined(&ide_init_hwif_ports);
	unless(defined(&CONFIG_BLK_DEV_IDEPCI)) {
	}
	eval 'sub __ide_insl {
	    my($data_reg, $buffer, $wcount) = @_;
    	    eval q( &__ide_insw($data_reg, $buffer, ($wcount)<<1));
	}' unless defined(&__ide_insl);
	eval 'sub __ide_outsl {
	    my($data_reg, $buffer, $wcount) = @_;
    	    eval q( &__ide_outsw($data_reg, $buffer, ($wcount)<<1));
	}' unless defined(&__ide_outsl);
	eval 'sub __ide_mm_insw () { &__ide_insw;}' unless defined(&__ide_mm_insw);
	eval 'sub __ide_mm_insl () { &__ide_insl;}' unless defined(&__ide_mm_insl);
	eval 'sub __ide_mm_outsw () { &__ide_outsw;}' unless defined(&__ide_mm_outsw);
	eval 'sub __ide_mm_outsl () { &__ide_outsl;}' unless defined(&__ide_mm_outsl);
	eval 'sub inw_be {
	    my($addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&inw_be);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __ide_insw {
	    my($port,$dst,$count) = @_;
    	    eval q({  &u16 * &ps = $dst;  &u32 * &pi;  &if((( &u64) &ps) & 0x2) { * &ps++ =  &inw_be($port); $count--; }  &pi = ( &u32 *) &ps;  &while($count >= 2) {  &u32  &w;  &w =  &inw_be($port) << 16;  &w |=  &inw_be($port); * &pi++ =  &w; $count -= 2; }  &ps = ( &u16 *) &pi;  &if($count) * &ps++ =  &inw_be($port); });
	}' unless defined(&__ide_insw);
	eval 'sub outw_be {
	    my($w,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&outw_be);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __ide_outsw {
	    my($port,$src,$count) = @_;
    	    eval q({  &const  &u16 * &ps = $src;  &const  &u32 * &pi;  &if((( &u64)$src) & 0x2) {  &outw_be(* &ps++, $port); $count--; }  &pi = ( &const  &u32 *) &ps;  &while($count >= 2) {  &u32  &w;  &w = * &pi++;  &outw_be(( &w >> 16), $port);  &outw_be( &w, $port); $count -= 2; }  &ps = ( &const  &u16 *) &pi;  &if($count)  &outw_be(* &ps, $port); });
	}' unless defined(&__ide_outsw);
    }
}
1;
