require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC64_IO_H)) {
    eval 'sub __SPARC64_IO_H () {1;}' unless defined(&__SPARC64_IO_H);
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'asm/page.ph';
    require 'asm/system.ph';
    require 'asm/asi.ph';
    eval 'sub __SLOW_DOWN_IO () { &do { }  &while (0);}' unless defined(&__SLOW_DOWN_IO);
    eval 'sub SLOW_DOWN_IO () { &do { }  &while (0);}' unless defined(&SLOW_DOWN_IO);
    eval 'sub virt_to_bus () { &virt_to_bus_not_defined_use_pci_map;}' unless defined(&virt_to_bus);
    eval 'sub bus_to_virt () { &bus_to_virt_not_defined_use_pci_map;}' unless defined(&bus_to_virt);
    eval 'sub page_to_phys {
        my($page) = @_;
	    eval q((((($page) -  &mem_map) <<  &PAGE_SHIFT)+ &phys_base));
    }' unless defined(&page_to_phys);
    eval 'sub BIO_VMERGE_BOUNDARY () {8192;}' unless defined(&BIO_VMERGE_BOUNDARY);
    eval 'sub bus_dvma_to_mem {
        my($__vaddr) = @_;
	    eval q((($__vaddr) &  &pci_memspace_mask));
    }' unless defined(&bus_dvma_to_mem);
    eval 'sub _inb {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_inb);
    eval 'sub _inw {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_inw);
    eval 'sub _inl {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_inl);
    eval 'sub _outb {
        my($b,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_outb);
    eval 'sub _outw {
        my($w,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_outw);
    eval 'sub _outl {
        my($l,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_outl);
    eval 'sub inb {
        my($__addr) = @_;
	    eval q(( &_inb(($__addr))));
    }' unless defined(&inb);
    eval 'sub inw {
        my($__addr) = @_;
	    eval q(( &_inw(($__addr))));
    }' unless defined(&inw);
    eval 'sub inl {
        my($__addr) = @_;
	    eval q(( &_inl(($__addr))));
    }' unless defined(&inl);
    eval 'sub outb {
        my($__b, $__addr) = @_;
	    eval q(( &_outb(( &u8), ($__addr))));
    }' unless defined(&outb);
    eval 'sub outw {
        my($__w, $__addr) = @_;
	    eval q(( &_outw(( &u16), ($__addr))));
    }' unless defined(&outw);
    eval 'sub outl {
        my($__l, $__addr) = @_;
	    eval q(( &_outl(( &u32), ($__addr))));
    }' unless defined(&outl);
    eval 'sub inb_p {
        my($__addr) = @_;
	    eval q( &inb($__addr));
    }' unless defined(&inb_p);
    eval 'sub outb_p {
        my($__b, $__addr) = @_;
	    eval q( &outb($__b, $__addr));
    }' unless defined(&outb_p);
    eval 'sub inw_p {
        my($__addr) = @_;
	    eval q( &inw($__addr));
    }' unless defined(&inw_p);
    eval 'sub outw_p {
        my($__w, $__addr) = @_;
	    eval q( &outw($__w, $__addr));
    }' unless defined(&outw_p);
    eval 'sub inl_p {
        my($__addr) = @_;
	    eval q( &inl($__addr));
    }' unless defined(&inl_p);
    eval 'sub outl_p {
        my($__l, $__addr) = @_;
	    eval q( &outl($__l, $__addr));
    }' unless defined(&outl_p);
    eval 'sub _readw {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_readw);
    eval 'sub _readl {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_readl);
    eval 'sub _readq {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_readq);
    eval 'sub _writeb {
        my($b,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_writeb);
    eval 'sub _writew {
        my($w,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_writew);
    eval 'sub _writel {
        my($l,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_writel);
    eval 'sub _writeq {
        my($q,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_writeq);
    eval 'sub readb {
        my($__addr) = @_;
	    eval q(( &_readb(($__addr))));
    }' unless defined(&readb);
    eval 'sub readw {
        my($__addr) = @_;
	    eval q(( &_readw(($__addr))));
    }' unless defined(&readw);
    eval 'sub readl {
        my($__addr) = @_;
	    eval q(( &_readl(($__addr))));
    }' unless defined(&readl);
    eval 'sub readq {
        my($__addr) = @_;
	    eval q(( &_readq(($__addr))));
    }' unless defined(&readq);
    eval 'sub readb_relaxed {
        my($a) = @_;
	    eval q( &readb($a));
    }' unless defined(&readb_relaxed);
    eval 'sub readw_relaxed {
        my($a) = @_;
	    eval q( &readw($a));
    }' unless defined(&readw_relaxed);
    eval 'sub readl_relaxed {
        my($a) = @_;
	    eval q( &readl($a));
    }' unless defined(&readl_relaxed);
    eval 'sub readq_relaxed {
        my($a) = @_;
	    eval q( &readq($a));
    }' unless defined(&readq_relaxed);
    eval 'sub writeb {
        my($__b, $__addr) = @_;
	    eval q(( &_writeb(( &u8), ($__addr))));
    }' unless defined(&writeb);
    eval 'sub writew {
        my($__w, $__addr) = @_;
	    eval q(( &_writew(( &u16), ($__addr))));
    }' unless defined(&writew);
    eval 'sub writel {
        my($__l, $__addr) = @_;
	    eval q(( &_writel(( &u32), ($__addr))));
    }' unless defined(&writel);
    eval 'sub writeq {
        my($__q, $__addr) = @_;
	    eval q(( &_writeq(( &u64), ($__addr))));
    }' unless defined(&writeq);
    eval 'sub _raw_readw {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_raw_readw);
    eval 'sub _raw_readl {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_raw_readl);
    eval 'sub _raw_readq {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_raw_readq);
    eval 'sub _raw_writeb {
        my($b,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_raw_writeb);
    eval 'sub _raw_writew {
        my($w,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_raw_writew);
    eval 'sub _raw_writel {
        my($l,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_raw_writel);
    eval 'sub _raw_writeq {
        my($q,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_raw_writeq);
    eval 'sub __raw_readb {
        my($__addr) = @_;
	    eval q(( &_raw_readb(($__addr))));
    }' unless defined(&__raw_readb);
    eval 'sub __raw_readw {
        my($__addr) = @_;
	    eval q(( &_raw_readw(($__addr))));
    }' unless defined(&__raw_readw);
    eval 'sub __raw_readl {
        my($__addr) = @_;
	    eval q(( &_raw_readl(($__addr))));
    }' unless defined(&__raw_readl);
    eval 'sub __raw_readq {
        my($__addr) = @_;
	    eval q(( &_raw_readq(($__addr))));
    }' unless defined(&__raw_readq);
    eval 'sub __raw_writeb {
        my($__b, $__addr) = @_;
	    eval q(( &_raw_writeb(( &u8), ($__addr))));
    }' unless defined(&__raw_writeb);
    eval 'sub __raw_writew {
        my($__w, $__addr) = @_;
	    eval q(( &_raw_writew(( &u16), ($__addr))));
    }' unless defined(&__raw_writew);
    eval 'sub __raw_writel {
        my($__l, $__addr) = @_;
	    eval q(( &_raw_writel(( &u32), ($__addr))));
    }' unless defined(&__raw_writel);
    eval 'sub __raw_writeq {
        my($__q, $__addr) = @_;
	    eval q(( &_raw_writeq(( &u64), ($__addr))));
    }' unless defined(&__raw_writeq);
    eval 'sub IO_SPACE_LIMIT () {1.84467440737096e+19;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub _sbus_readw {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_sbus_readw);
    eval 'sub _sbus_readl {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_sbus_readl);
    eval 'sub _sbus_readq {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_sbus_readq);
    eval 'sub _sbus_writeb {
        my($b,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_sbus_writeb);
    eval 'sub _sbus_writew {
        my($w,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_sbus_writew);
    eval 'sub _sbus_writel {
        my($l,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_sbus_writel);
    eval 'sub _sbus_writeq {
        my($l,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&_sbus_writeq);
    eval 'sub sbus_readb {
        my($__addr) = @_;
	    eval q(( &_sbus_readb(($__addr))));
    }' unless defined(&sbus_readb);
    eval 'sub sbus_readw {
        my($__addr) = @_;
	    eval q(( &_sbus_readw(($__addr))));
    }' unless defined(&sbus_readw);
    eval 'sub sbus_readl {
        my($__addr) = @_;
	    eval q(( &_sbus_readl(($__addr))));
    }' unless defined(&sbus_readl);
    eval 'sub sbus_readq {
        my($__addr) = @_;
	    eval q(( &_sbus_readq(($__addr))));
    }' unless defined(&sbus_readq);
    eval 'sub sbus_writeb {
        my($__b, $__addr) = @_;
	    eval q(( &_sbus_writeb(, ($__addr))));
    }' unless defined(&sbus_writeb);
    eval 'sub sbus_writew {
        my($__w, $__addr) = @_;
	    eval q(( &_sbus_writew(, ($__addr))));
    }' unless defined(&sbus_writew);
    eval 'sub sbus_writel {
        my($__l, $__addr) = @_;
	    eval q(( &_sbus_writel(, ($__addr))));
    }' unless defined(&sbus_writel);
    eval 'sub sbus_writeq {
        my($__l, $__addr) = @_;
	    eval q(( &_sbus_writeq(, ($__addr))));
    }' unless defined(&sbus_writeq);
    eval 'sub void {
        eval q(* &_sbus_memset_io(my $dst, \'int\'  &c,  &__kernel_size_t  &n) {  &while( &n--) {  &sbus_writeb( &c,  $dst);  $dst++; } ( &void *)  $dst; });
    }' unless defined(&void);
    eval 'sub sbus_memset_io {
        my($d,$c,$sz) = @_;
	    eval q( &_sbus_memset_io($d,$c,( &__kernel_size_t)$sz));
    }' unless defined(&sbus_memset_io);
    eval 'sub _memset_io {
        my($dst,$c,$n) = @_;
	    eval q({ \'char\' * &d = $dst;  &while ($n--) {  &writeb($c,  &d);  &d++; } $dst; });
    }' unless defined(&_memset_io);
    eval 'sub memset_io {
        my($d,$c,$sz) = @_;
	    eval q( &_memset_io(( &void *)$d,$c,( &__kernel_size_t)$sz));
    }' unless defined(&memset_io);
    eval 'sub _memcpy_fromio {
        my($dst,$src,$n) = @_;
	    eval q({ \'char\' * &d = $dst;  &while ($n--) { \'char\'  &tmp =  &readb($src); * &d++ =  &tmp; $src++; } $dst; });
    }' unless defined(&_memcpy_fromio);
    eval 'sub memcpy_fromio {
        my($d,$s,$sz) = @_;
	    eval q( &_memcpy_fromio(( &void *)$d,$s,( &__kernel_size_t)$sz));
    }' unless defined(&memcpy_fromio);
    eval 'sub _memcpy_toio {
        my($dst,$src,$n) = @_;
	    eval q({  &const \'char\' * &s = $src; my $d = $dst;  &while ($n--) { \'char\'  &tmp = * &s++;  &writeb( &tmp,  $d);  $d++; } ( &void *)$dst; });
    }' unless defined(&_memcpy_toio);
    eval 'sub memcpy_toio {
        my($d,$s,$sz) = @_;
	    eval q( &_memcpy_toio($d,( &const  &void *)$s,( &__kernel_size_t)$sz));
    }' unless defined(&memcpy_toio);
    eval 'sub check_signature {
        my($io_addr,$signature,$length) = @_;
	    eval q({ \'int\'  &retval = 0;  &do {  &if ( &readb($io_addr++) != *$signature++)  &goto  &out; }  &while (--$length);  &retval = 1;  &out:  &retval; });
    }' unless defined(&check_signature);
    if(defined(&__KERNEL__)) {
	eval 'sub ioremap {
	    my($__offset, $__size) = @_;
    	    eval q((( &void *)($__offset)));
	}' unless defined(&ioremap);
	eval 'sub ioremap_nocache {
	    my($X,$Y) = @_;
    	    eval q( &ioremap(($X),($Y)));
	}' unless defined(&ioremap_nocache);
	eval 'sub iounmap {
	    my($__addr) = @_;
    	    eval q( &do { ( &void)($__addr); }  &while(0));
	}' unless defined(&iounmap);
	eval 'sub sbus_ioremap {
	    my($__res, $__offset, $__size, $__name) = @_;
    	    eval q(({ \'unsigned long __ret\';  &__ret = -> &start + ((-> &flags & 0x1ff) << 32);  &__ret += ($__offset);  &if (!  &request_region(( &__ret), ($__size), ($__name)))  &__ret = 0;  &__ret; }));
	}' unless defined(&sbus_ioremap);
	eval 'sub sbus_iounmap {
	    my($__addr, $__size) = @_;
    	    eval q( &release_region(($__addr), ($__size)));
	}' unless defined(&sbus_iounmap);
	eval 'sub dma_cache_inv {
	    my($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    my($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    my($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
}
1;
