require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_PGALLOC_H)) {
    eval 'sub _SPARC64_PGALLOC_H () {1;}' unless defined(&_SPARC64_PGALLOC_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    require 'linux/sched.ph';
    require 'linux/mm.ph';
    require 'asm/page.ph';
    require 'asm/spitfire.ph';
    require 'asm/pgtable.ph';
    require 'asm/cpudata.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub pgt_quicklists () { &cpu_data( &smp_processor_id());}' unless defined(&pgt_quicklists);
    } else {
    }
    eval 'sub pgd_quicklist () {( ($pgt_quicklists->{pgd_cache}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {( ($pgt_quicklists->{pte_cache}));}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {( ($pgt_quicklists->{pgcache_size}));}' unless defined(&pgtable_cache_size);
    eval 'sub pgd_cache_size () {( ($pgt_quicklists->{pgdcache_size}));}' unless defined(&pgd_cache_size);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub free_pgd_fast {
	    my($pgd) = @_;
    	    eval q({ \'struct page\' * &page =  &virt_to_page;  &preempt_disable();  &if (! ($page->{lru}->{prev})) {  ($page->{lru}->{next}) =  &pgd_quicklist;  &pgd_quicklist =  &page; }  ($page->{lru}->{prev}) |= (($pgd & ( &PAGE_SIZE / 2)) ? 2: 1);  &pgd_cache_size++;  &preempt_enable(); });
	}' unless defined(&free_pgd_fast);
	eval 'sub pgd_t {
	    eval q(* &get_pgd_fast( &void) { \'struct page\' * &ret;  &preempt_disable();  &if (( &ret =  &pgd_quicklist) !=  &NULL) { my $mask =  ($ret->{lru}->{prev}); my $off = 0;  &if ( $mask & 1)  $mask &= ~1;  &else {  $off =  &PAGE_SIZE / 2;  $mask &= ~2; }  ($ret->{lru}->{prev}) =  $mask;  &if (! $mask)  &pgd_quicklist =  ($ret->{lru}->{next});  &ret = ( &__page_address( &ret) +  $off);  &pgd_cache_size--;  &preempt_enable(); }  &else { \'struct page\' * &page;  &preempt_enable();  &page =  &alloc_page( &GFP_KERNEL| &__GFP_REPEAT);  &if ( &page) {  &ret =  &page_address;  &clear_page;  ($page->{lru}->{prev}) = 2;  &preempt_disable();  ($page->{lru}->{next}) =  &pgd_quicklist;  &pgd_quicklist =  &page;  &pgd_cache_size++;  &preempt_enable(); } } ( &pgd_t *) &ret; });
	}' unless defined(&pgd_t);
    } else {
	eval 'sub free_pgd_fast {
	    my($pgd) = @_;
    	    eval q({  &preempt_disable(); *$pgd =  &pgd_quicklist;  &pgd_quicklist = $pgd;  &pgtable_cache_size++;  &preempt_enable(); });
	}' unless defined(&free_pgd_fast);
	eval 'sub pgd_t {
	    eval q(* &get_pgd_fast { my $long * &ret;  &preempt_disable();  &if(( &ret =  &pgd_quicklist) !=  &NULL) {  &pgd_quicklist = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--;  &preempt_enable(); }  &else {  &preempt_enable();  &ret =  &__get_free_page( &GFP_KERNEL| &__GFP_REPEAT);  &if( &ret)  &memset( &ret, 0,  &PAGE_SIZE); } ( &pgd_t *) &ret; });
	}' unless defined(&pgd_t);
	eval 'sub free_pgd_slow {
	    my($pgd) = @_;
    	    eval q({  &free_page($pgd); });
	}' unless defined(&free_pgd_slow);
    }
    if(((defined(&L1DCACHE_SIZE) ? &L1DCACHE_SIZE : undef) > (defined(&PAGE_SIZE) ? &PAGE_SIZE : undef)) ) {
	eval 'sub VPTE_COLOR {
	    my($address) = @_;
    	    eval q(((($address) >> ( &PAGE_SHIFT + 10)) & 1));
	}' unless defined(&VPTE_COLOR);
	eval 'sub DCACHE_COLOR {
	    my($address) = @_;
    	    eval q(((($address) >>  &PAGE_SHIFT) & 1));
	}' unless defined(&DCACHE_COLOR);
    } else {
	eval 'sub VPTE_COLOR {
	    my($address) = @_;
    	    eval q(0);
	}' unless defined(&VPTE_COLOR);
	eval 'sub DCACHE_COLOR {
	    my($address) = @_;
    	    eval q(0);
	}' unless defined(&DCACHE_COLOR);
    }
    eval 'sub pgd_populate {
        my($MM, $PGD, $PMD) = @_;
	    eval q( &pgd_set($PGD, $PMD));
    }' unless defined(&pgd_populate);
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one_fast(\'struct mm_struct\' * &mm, my $address) { my $long * &ret; \'int\'  &color = 0;  &preempt_disable();  &if ( $pte_quicklist[ &color] ==  &NULL)  &color = 1;  &if(( &ret =  $pte_quicklist[ &color]) !=  &NULL) {  $pte_quicklist[ &color] = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--; }  &preempt_enable(); ( &pmd_t *) &ret; });
    }' unless defined(&pmd_t);
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &pmd_t * &pmd;  &pmd =  &pmd_alloc_one_fast( &mm,  $address);  &if (! &pmd) {  &pmd = ( &pmd_t *) &__get_free_page( &GFP_KERNEL| &__GFP_REPEAT);  &if ( &pmd)  &memset( &pmd, 0,  &PAGE_SIZE); }  &pmd; });
    }' unless defined(&pmd_t);
    eval 'sub free_pmd_fast {
        my($pmd) = @_;
	    eval q({ my $color =  &DCACHE_COLOR;  &preempt_disable(); *$pmd =  $pte_quicklist[ $color];  $pte_quicklist[ $color] = $pmd;  &pgtable_cache_size++;  &preempt_enable(); });
    }' unless defined(&free_pmd_fast);
    eval 'sub free_pmd_slow {
        my($pmd) = @_;
	    eval q({  &free_page($pmd); });
    }' unless defined(&free_pmd_slow);
    eval 'sub pmd_populate_kernel {
        my($MM, $PMD, $PTE) = @_;
	    eval q( &pmd_set($PMD, $PTE));
    }' unless defined(&pmd_populate_kernel);
    eval 'sub pmd_populate {
        my($MM,$PMD,$PTE_PAGE) = @_;
	    eval q( &pmd_populate_kernel($MM,$PMD, &page_address($PTE_PAGE)));
    }' unless defined(&pmd_populate);
    eval 'sub pte_alloc_one {
        my($MM,$ADDR) = @_;
	    eval q( &virt_to_page( &pte_alloc_one_kernel($MM,$ADDR)));
    }' unless defined(&pte_alloc_one);
    eval 'sub pte_t {
        eval q(* &pte_alloc_one_fast(\'struct mm_struct\' * &mm, my $address) { my $color =  &VPTE_COLOR; my $long * &ret;  &preempt_disable();  &if(( &ret =  $pte_quicklist[ $color]) !=  &NULL) {  $pte_quicklist[ $color] = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--; }  &preempt_enable(); ( &pte_t *) &ret; });
    }' unless defined(&pte_t);
    eval 'sub free_pte_fast {
        my($pte) = @_;
	    eval q({ my $color =  &DCACHE_COLOR;  &preempt_disable(); *$pte =  $pte_quicklist[ $color];  $pte_quicklist[ $color] = $pte;  &pgtable_cache_size++;  &preempt_enable(); });
    }' unless defined(&free_pte_fast);
    eval 'sub free_pte_slow {
        my($pte) = @_;
	    eval q({  &free_page($pte); });
    }' unless defined(&free_pte_slow);
    eval 'sub pte_free_kernel {
        my($pte) = @_;
	    eval q( &free_pte_fast($pte));
    }' unless defined(&pte_free_kernel);
    eval 'sub pte_free {
        my($pte) = @_;
	    eval q( &free_pte_fast( &page_address($pte)));
    }' unless defined(&pte_free);
    eval 'sub pmd_free {
        my($pmd) = @_;
	    eval q( &free_pmd_fast($pmd));
    }' unless defined(&pmd_free);
    eval 'sub pgd_free {
        my($pgd) = @_;
	    eval q( &free_pgd_fast($pgd));
    }' unless defined(&pgd_free);
    eval 'sub pgd_alloc {
        my($mm) = @_;
	    eval q( &get_pgd_fast());
    }' unless defined(&pgd_alloc);
    eval 'sub arch_add_exec_range {
        my($mm, $limit) = @_;
	    eval q( &do { ; }  &while (0));
    }' unless defined(&arch_add_exec_range);
    eval 'sub arch_flush_exec_range {
        my($mm) = @_;
	    eval q( &do { ; }  &while (0));
    }' unless defined(&arch_flush_exec_range);
    eval 'sub arch_remove_exec_range {
        my($mm, $limit) = @_;
	    eval q( &do { ; }  &while (0));
    }' unless defined(&arch_remove_exec_range);
}
1;
