require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_TLBFLUSH_H)) {
    eval 'sub _SPARC64_TLBFLUSH_H () {1;}' unless defined(&_SPARC64_TLBFLUSH_H);
    require 'linux/config.ph';
    require 'linux/mm.ph';
    require 'asm/mmu_context.ph';
    unless(defined(&CONFIG_SMP)) {
	eval 'sub flush_tlb_all () {
	    eval q( &__flush_tlb_all());
	}' unless defined(&flush_tlb_all);
	eval 'sub flush_tlb_kernel_range {
	    my($start,$end) = @_;
    	    eval q( &__flush_tlb_kernel_range($start,$end));
	}' unless defined(&flush_tlb_kernel_range);
	eval 'sub flush_tlb_mm {
	    my($__mm) = @_;
    	    eval q( &do {  &if ( &CTX_VALID(($__mm)-> &context))  &__flush_tlb_mm( &CTX_HWBITS(($__mm)-> &context),  &SECONDARY_CONTEXT); }  &while (0));
	}' unless defined(&flush_tlb_mm);
	eval 'sub flush_tlb_range {
	    my($__vma, $start, $end) = @_;
    	    eval q( &do {  &if ( &CTX_VALID(($__vma)-> ($vm_mm->{context}))) { \'unsigned long __start\' = ($start) &PAGE_MASK; \'unsigned long __end\' =  &PAGE_ALIGN($end);  &__flush_tlb_range( &CTX_HWBITS(($__vma)-> ($vm_mm->{context})),  &__start,  &SECONDARY_CONTEXT,  &__end,  &PAGE_SIZE, ( &__end -  &__start)); } }  &while (0));
	}' unless defined(&flush_tlb_range);
	eval 'sub flush_tlb_vpte_range {
	    my($__mm, $start, $end) = @_;
    	    eval q( &do {  &if ( &CTX_VALID(($__mm)-> &context)) { \'unsigned long __start\' = ($start) &PAGE_MASK; \'unsigned long __end\' =  &PAGE_ALIGN($end);  &__flush_tlb_range( &CTX_HWBITS(($__mm)-> &context),  &__start,  &SECONDARY_CONTEXT,  &__end,  &PAGE_SIZE, ( &__end -  &__start)); } }  &while (0));
	}' unless defined(&flush_tlb_vpte_range);
	eval 'sub flush_tlb_page {
	    my($vma, $page) = @_;
    	    eval q( &do { \'struct mm_struct\' * &__mm = ($vma)-> &vm_mm;  &if ( &CTX_VALID( ($__mm->{context})))  &__flush_tlb_page( &CTX_HWBITS( ($__mm->{context})), ($page) &PAGE_MASK,  &SECONDARY_CONTEXT); }  &while (0));
	}' unless defined(&flush_tlb_page);
	eval 'sub flush_tlb_vpte_page {
	    my($mm, $addr) = @_;
    	    eval q( &do { \'struct mm_struct\' * &__mm = ($mm);  &if ( &CTX_VALID( ($__mm->{context})))  &__flush_tlb_page( &CTX_HWBITS( ($__mm->{context})), ($addr) &PAGE_MASK,  &SECONDARY_CONTEXT); }  &while (0));
	}' unless defined(&flush_tlb_vpte_page);
    } else {
	eval 'sub flush_tlb_all () {
	    eval q( &smp_flush_tlb_all());
	}' unless defined(&flush_tlb_all);
	eval 'sub flush_tlb_mm {
	    my($mm) = @_;
    	    eval q( &smp_flush_tlb_mm($mm));
	}' unless defined(&flush_tlb_mm);
	eval 'sub flush_tlb_range {
	    my($vma, $start, $end) = @_;
    	    eval q( &smp_flush_tlb_range(($vma)-> &vm_mm, $start, $end));
	}' unless defined(&flush_tlb_range);
	eval 'sub flush_tlb_vpte_range {
	    my($mm, $start, $end) = @_;
    	    eval q( &smp_flush_tlb_range($mm, $start, $end));
	}' unless defined(&flush_tlb_vpte_range);
	eval 'sub flush_tlb_kernel_range {
	    my($start, $end) = @_;
    	    eval q( &smp_flush_tlb_kernel_range($start, $end));
	}' unless defined(&flush_tlb_kernel_range);
	eval 'sub flush_tlb_page {
	    my($vma, $page) = @_;
    	    eval q( &smp_flush_tlb_page(($vma)-> &vm_mm, $page));
	}' unless defined(&flush_tlb_page);
	eval 'sub flush_tlb_vpte_page {
	    my($mm, $page) = @_;
    	    eval q( &smp_flush_tlb_page(($mm), $page));
	}' unless defined(&flush_tlb_vpte_page);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub flush_tlb_pgtables {
        my($mm,$start,$end) = @_;
	    eval q({ my $s = $start,  &e = $end,  &vpte_base;  &BUG_ON( $s >  &e);  &vpte_base = ( &tlb_type ==  &spitfire ?  &VPTE_BASE_SPITFIRE :  &VPTE_BASE_CHEETAH);  &flush_tlb_vpte_range($mm,  &vpte_base + ( $s >> ( &PAGE_SHIFT - 3)),  &vpte_base + ( &e >> ( &PAGE_SHIFT - 3))); });
    }' unless defined(&flush_tlb_pgtables);
}
1;
