require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_MTD_MAP_H__)) {
    eval 'sub __LINUX_MTD_MAP_H__ () {1;}' unless defined(&__LINUX_MTD_MAP_H__);
    require 'linux/config.ph';
    require 'linux/types.ph';
    require 'linux/list.ph';
    require 'asm/system.ph';
    require 'asm/io.ph';
    eval 'sub NO_XIP () {(-1);}' unless defined(&NO_XIP);
    if(defined(&CONFIG_MTD_COMPLEX_MAPPINGS)) {
    }
    eval 'sub ENABLE_VPP {
        my($map) = @_;
	    eval q( &do {  &if( ($map->{set_vpp}))  ($map->{set_vpp})($map, 1); }  &while(0));
    }' unless defined(&ENABLE_VPP);
    eval 'sub DISABLE_VPP {
        my($map) = @_;
	    eval q( &do {  &if( ($map->{set_vpp}))  ($map->{set_vpp})($map, 0); }  &while(0));
    }' unless defined(&DISABLE_VPP);
    if(defined(&CONFIG_MTD_COMPLEX_MAPPINGS)) {
	eval 'sub map_read8 {
	    my($map, $ofs) = @_;
    	    eval q(($map)-> &read8($map, $ofs));
	}' unless defined(&map_read8);
	eval 'sub map_read16 {
	    my($map, $ofs) = @_;
    	    eval q(($map)-> &read16($map, $ofs));
	}' unless defined(&map_read16);
	eval 'sub map_read32 {
	    my($map, $ofs) = @_;
    	    eval q(($map)-> &read32($map, $ofs));
	}' unless defined(&map_read32);
	eval 'sub map_read64 {
	    my($map, $ofs) = @_;
    	    eval q(($map)-> &read64($map, $ofs));
	}' unless defined(&map_read64);
	eval 'sub map_copy_from {
	    my($map, $to, $from, $len) = @_;
    	    eval q(($map)-> &copy_from($map, $to, $from, $len));
	}' unless defined(&map_copy_from);
	eval 'sub map_write8 {
	    my($map, $datum, $ofs) = @_;
    	    eval q(($map)-> &write8($map, $datum, $ofs));
	}' unless defined(&map_write8);
	eval 'sub map_write16 {
	    my($map, $datum, $ofs) = @_;
    	    eval q(($map)-> &write16($map, $datum, $ofs));
	}' unless defined(&map_write16);
	eval 'sub map_write32 {
	    my($map, $datum, $ofs) = @_;
    	    eval q(($map)-> &write32($map, $datum, $ofs));
	}' unless defined(&map_write32);
	eval 'sub map_write64 {
	    my($map, $datum, $ofs) = @_;
    	    eval q(($map)-> &write64($map, $datum, $ofs));
	}' unless defined(&map_write64);
	eval 'sub map_copy_to {
	    my($map, $to, $from, $len) = @_;
    	    eval q(($map)-> &copy_to($map, $to, $from, $len));
	}' unless defined(&map_copy_to);
	eval 'sub map_is_linear {
	    my($map) = @_;
    	    eval q(( ($map->{phys}) !=  &NO_XIP));
	}' unless defined(&map_is_linear);
    } else {
	eval 'sub map_read8 {
	    my($map,$ofs) = @_;
    	    eval q({  &__raw_readb( ($map->{virt}) + $ofs); });
	}' unless defined(&map_read8);
	eval 'sub map_read16 {
	    my($map,$ofs) = @_;
    	    eval q({  &__raw_readw( ($map->{virt}) + $ofs); });
	}' unless defined(&map_read16);
	eval 'sub map_read32 {
	    my($map,$ofs) = @_;
    	    eval q({  &__raw_readl( ($map->{virt}) + $ofs); });
	}' unless defined(&map_read32);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub map_read64 {
	    my($map,$ofs) = @_;
    	    eval q({ });
	}' unless defined(&map_read64);
	eval 'sub map_write8 {
	    my($map,$datum,$ofs) = @_;
    	    eval q({  &__raw_writeb($datum,  ($map->{virt}) + $ofs);  &mb(); });
	}' unless defined(&map_write8);
	eval 'sub map_write16 {
	    my($map,$datum,$ofs) = @_;
    	    eval q({  &__raw_writew($datum,  ($map->{virt}) + $ofs);  &mb(); });
	}' unless defined(&map_write16);
	eval 'sub map_write32 {
	    my($map,$datum,$ofs) = @_;
    	    eval q({  &__raw_writel($datum,  ($map->{virt}) + $ofs);  &mb(); });
	}' unless defined(&map_write32);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub map_write64 {
	    my($map,$datum,$ofs) = @_;
    	    eval q({ });
	}' unless defined(&map_write64);
	eval 'sub map_copy_from {
	    my($map,$to,$from,$len) = @_;
    	    eval q({  &memcpy_fromio($to,  ($map->{virt}) + $from, $len); });
	}' unless defined(&map_copy_from);
	eval 'sub map_copy_to {
	    my($map,$to,$from,$len) = @_;
    	    eval q({  &memcpy_toio( ($map->{virt}) + $to, $from, $len); });
	}' unless defined(&map_copy_to);
	eval 'sub simple_map_init {
	    my($map) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&simple_map_init);
	eval 'sub map_is_linear {
	    my($map) = @_;
    	    eval q((1));
	}' unless defined(&map_is_linear);
    }
}
1;
