require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LOCKHELP_H)) {
    eval 'sub _LOCKHELP_H () {1;}' unless defined(&_LOCKHELP_H);
    require 'linux/config.ph';
    require 'linux/spinlock.ph';
    require 'asm/atomic.ph';
    require 'linux/interrupt.ph';
    require 'linux/smp.ph';
    if(defined(&CONFIG_NETFILTER_DEBUG)) {
	eval 'sub DECLARE_LOCK {
	    my($l) = @_;
    	    eval q(\'struct spinlock_debug\' $l = {  &SPIN_LOCK_UNLOCKED,  &ATOMIC_INIT(-1) });
	}' unless defined(&DECLARE_LOCK);
	eval 'sub DECLARE_LOCK_EXTERN {
	    my($l) = @_;
    	    eval q( &extern \'struct spinlock_debug\' $l);
	}' unless defined(&DECLARE_LOCK_EXTERN);
	eval 'sub DECLARE_RWLOCK {
	    my($l) = @_;
    	    eval q(\'struct rwlock_debug\' $l = {  &RW_LOCK_UNLOCKED, 0, 0});
	}' unless defined(&DECLARE_RWLOCK);
	eval 'sub DECLARE_RWLOCK_EXTERN {
	    my($l) = @_;
    	    eval q( &extern \'struct rwlock_debug\' $l);
	}' unless defined(&DECLARE_RWLOCK_EXTERN);
	eval 'sub MUST_BE_LOCKED {
	    my($l) = @_;
    	    eval q( &do {  &if ( &atomic_read(($l)-> &locked_by) !=  &smp_processor_id())  &printk(\\"ASSERT %s:%u %s unlocked\\\\n\\",  &__FILE__,  &__LINE__, $l); }  &while(0));
	}' unless defined(&MUST_BE_LOCKED);
	eval 'sub MUST_BE_UNLOCKED {
	    my($l) = @_;
    	    eval q( &do {  &if ( &atomic_read(($l)-> &locked_by) ==  &smp_processor_id())  &printk(\\"ASSERT %s:%u %s locked\\\\n\\",  &__FILE__,  &__LINE__, $l); }  &while(0));
	}' unless defined(&MUST_BE_UNLOCKED);
	eval 'sub MUST_BE_READ_LOCKED {
	    my($l) = @_;
    	    eval q( &do {  &if (!(($l)-> &read_locked_map & (1 <<  &smp_processor_id()))  && !(($l)-> &write_locked_map & (1 <<  &smp_processor_id())))  &printk(\\"ASSERT %s:%u %s not readlocked\\\\n\\",  &__FILE__,  &__LINE__, $l); }  &while(0));
	}' unless defined(&MUST_BE_READ_LOCKED);
	eval 'sub MUST_BE_WRITE_LOCKED {
	    my($l) = @_;
    	    eval q( &do {  &if (!(($l)-> &write_locked_map & (1 <<  &smp_processor_id())))  &printk(\\"ASSERT %s:%u %s not writelocked\\\\n\\",  &__FILE__,  &__LINE__, $l); }  &while(0));
	}' unless defined(&MUST_BE_WRITE_LOCKED);
	eval 'sub MUST_BE_READ_WRITE_UNLOCKED {
	    my($l) = @_;
    	    eval q( &do {  &if (($l)-> &read_locked_map & (1 <<  &smp_processor_id()))  &printk(\\"ASSERT %s:%u %s readlocked\\\\n\\",  &__FILE__,  &__LINE__, $l);  &else  &if (($l)-> &write_locked_map & (1 <<  &smp_processor_id()))  &printk(\\"ASSERT %s:%u %s writelocked\\\\n\\",  &__FILE__,  &__LINE__, $l); }  &while(0));
	}' unless defined(&MUST_BE_READ_WRITE_UNLOCKED);
	eval 'sub LOCK_BH {
	    my($lk) = @_;
    	    eval q( &do {  &MUST_BE_UNLOCKED($lk);  &spin_lock_bh(($lk)-> &l);  &atomic_set(($lk)-> &locked_by,  &smp_processor_id()); }  &while(0));
	}' unless defined(&LOCK_BH);
	eval 'sub UNLOCK_BH {
	    my($lk) = @_;
    	    eval q( &do {  &MUST_BE_LOCKED($lk);  &atomic_set(($lk)-> &locked_by, -1);  &spin_unlock_bh(($lk)-> &l); }  &while(0));
	}' unless defined(&UNLOCK_BH);
	eval 'sub READ_LOCK {
	    my($lk) = @_;
    	    eval q( &do {  &MUST_BE_READ_WRITE_UNLOCKED($lk);  &read_lock_bh(($lk)-> &l);  &set_bit( &smp_processor_id(), ($lk)-> &read_locked_map); }  &while(0));
	}' unless defined(&READ_LOCK);
	eval 'sub WRITE_LOCK {
	    my($lk) = @_;
    	    eval q( &do {  &MUST_BE_READ_WRITE_UNLOCKED($lk);  &write_lock_bh(($lk)-> &l);  &set_bit( &smp_processor_id(), ($lk)-> &write_locked_map); }  &while(0));
	}' unless defined(&WRITE_LOCK);
	eval 'sub READ_UNLOCK {
	    my($lk) = @_;
    	    eval q( &do {  &if (!(($lk)-> &read_locked_map & (1 <<  &smp_processor_id())))  &printk(\\"ASSERT: %s:%u %s not readlocked\\\\n\\",  &__FILE__,  &__LINE__, $lk);  &clear_bit( &smp_processor_id(), ($lk)-> &read_locked_map);  &read_unlock_bh(($lk)-> &l); }  &while(0));
	}' unless defined(&READ_UNLOCK);
	eval 'sub WRITE_UNLOCK {
	    my($lk) = @_;
    	    eval q( &do {  &MUST_BE_WRITE_LOCKED($lk);  &clear_bit( &smp_processor_id(), ($lk)-> &write_locked_map);  &write_unlock_bh(($lk)-> &l); }  &while(0));
	}' unless defined(&WRITE_UNLOCK);
    } else {
	eval 'sub DECLARE_LOCK {
	    my($l) = @_;
    	    eval q( &spinlock_t $l =  &SPIN_LOCK_UNLOCKED);
	}' unless defined(&DECLARE_LOCK);
	eval 'sub DECLARE_LOCK_EXTERN {
	    my($l) = @_;
    	    eval q( &extern  &spinlock_t $l);
	}' unless defined(&DECLARE_LOCK_EXTERN);
	eval 'sub DECLARE_RWLOCK {
	    my($l) = @_;
    	    eval q( &rwlock_t $l =  &RW_LOCK_UNLOCKED);
	}' unless defined(&DECLARE_RWLOCK);
	eval 'sub DECLARE_RWLOCK_EXTERN {
	    my($l) = @_;
    	    eval q( &extern  &rwlock_t $l);
	}' unless defined(&DECLARE_RWLOCK_EXTERN);
	eval 'sub MUST_BE_LOCKED {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&MUST_BE_LOCKED);
	eval 'sub MUST_BE_UNLOCKED {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&MUST_BE_UNLOCKED);
	eval 'sub MUST_BE_READ_LOCKED {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&MUST_BE_READ_LOCKED);
	eval 'sub MUST_BE_WRITE_LOCKED {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&MUST_BE_WRITE_LOCKED);
	eval 'sub MUST_BE_READ_WRITE_UNLOCKED {
	    my($l) = @_;
    	    eval q();
	}' unless defined(&MUST_BE_READ_WRITE_UNLOCKED);
	eval 'sub LOCK_BH {
	    my($l) = @_;
    	    eval q( &spin_lock_bh($l));
	}' unless defined(&LOCK_BH);
	eval 'sub UNLOCK_BH {
	    my($l) = @_;
    	    eval q( &spin_unlock_bh($l));
	}' unless defined(&UNLOCK_BH);
	eval 'sub READ_LOCK {
	    my($l) = @_;
    	    eval q( &read_lock_bh($l));
	}' unless defined(&READ_LOCK);
	eval 'sub WRITE_LOCK {
	    my($l) = @_;
    	    eval q( &write_lock_bh($l));
	}' unless defined(&WRITE_LOCK);
	eval 'sub READ_UNLOCK {
	    my($l) = @_;
    	    eval q( &read_unlock_bh($l));
	}' unless defined(&READ_UNLOCK);
	eval 'sub WRITE_UNLOCK {
	    my($l) = @_;
    	    eval q( &write_unlock_bh($l));
	}' unless defined(&WRITE_UNLOCK);
    }
}
1;
