require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MD_K_H)) {
    eval 'sub _MD_K_H () {1;}' unless defined(&_MD_K_H);
    eval 'sub MD_RESERVED () {0;}' unless defined(&MD_RESERVED);
    eval 'sub LINEAR () {1;}' unless defined(&LINEAR);
    eval 'sub RAID0 () {2;}' unless defined(&RAID0);
    eval 'sub RAID1 () {3;}' unless defined(&RAID1);
    eval 'sub RAID5 () {4;}' unless defined(&RAID5);
    eval 'sub TRANSLUCENT () {5;}' unless defined(&TRANSLUCENT);
    eval 'sub HSM () {6;}' unless defined(&HSM);
    eval 'sub MULTIPATH () {7;}' unless defined(&MULTIPATH);
    eval 'sub RAID6 () {8;}' unless defined(&RAID6);
    eval 'sub MAX_PERSONALITY () {9;}' unless defined(&MAX_PERSONALITY);
    eval 'sub LEVEL_MULTIPATH () {(-4);}' unless defined(&LEVEL_MULTIPATH);
    eval 'sub LEVEL_LINEAR () {(-1);}' unless defined(&LEVEL_LINEAR);
    eval 'sub MaxSector () {(~( &sector_t)0);}' unless defined(&MaxSector);
    eval 'sub MD_THREAD_NAME_MAX () {14;}' unless defined(&MD_THREAD_NAME_MAX);
    eval 'sub pers_to_level {
        my($pers) = @_;
	    eval q({  &switch ($pers) {  &case  &MULTIPATH:  &LEVEL_MULTIPATH;  &case  &HSM: -3;  &case  &TRANSLUCENT: -2;  &case  &LINEAR:  &LEVEL_LINEAR;  &case  &RAID0: 0;  &case  &RAID1: 1;  &case  &RAID5: 5;  &case  &RAID6: 6; }  &BUG();  &MD_RESERVED; });
    }' unless defined(&pers_to_level);
    eval 'sub level_to_pers {
        my($level) = @_;
	    eval q({  &switch ($level) {  &case  &LEVEL_MULTIPATH:  &MULTIPATH;  &case -3:  &HSM;  &case -2:  &TRANSLUCENT;  &case  &LEVEL_LINEAR:  &LINEAR;  &case 0:  &RAID0;  &case 1:  &RAID1;  &case 4:  &case 5:  &RAID5;  &case 6:  &RAID6; }  &MD_RESERVED; });
    }' unless defined(&level_to_pers);
    eval 'sub MAX_MD_DEVS () {256;}' unless defined(&MAX_MD_DEVS);
    eval 'sub MAX_CHUNK_SIZE () {(4096*1024);}' unless defined(&MAX_CHUNK_SIZE);
    eval 'sub disk_active {
        my($d) = @_;
	    eval q({  ($d->{state}) & (1<<  &MD_DISK_ACTIVE); });
    }' unless defined(&disk_active);
    eval 'sub disk_sync {
        my($d) = @_;
	    eval q({  ($d->{state}) & (1<<  &MD_DISK_SYNC); });
    }' unless defined(&disk_sync);
    eval 'sub disk_spare {
        my($d) = @_;
	    eval q({ ! &disk_sync($d)  && ! &disk_active($d)  && ! &disk_faulty($d); });
    }' unless defined(&disk_spare);
    eval 'sub disk_removed {
        my($d) = @_;
	    eval q({  ($d->{state}) & (1<<  &MD_DISK_REMOVED); });
    }' unless defined(&disk_removed);
    eval 'sub mark_disk_faulty {
        my($d) = @_;
	    eval q({  ($d->{state}) |= (1<<  &MD_DISK_FAULTY); });
    }' unless defined(&mark_disk_faulty);
    eval 'sub mark_disk_active {
        my($d) = @_;
	    eval q({  ($d->{state}) |= (1<<  &MD_DISK_ACTIVE); });
    }' unless defined(&mark_disk_active);
    eval 'sub mark_disk_sync {
        my($d) = @_;
	    eval q({  ($d->{state}) |= (1<<  &MD_DISK_SYNC); });
    }' unless defined(&mark_disk_sync);
    eval 'sub mark_disk_spare {
        my($d) = @_;
	    eval q({  ($d->{state}) = 0; });
    }' unless defined(&mark_disk_spare);
    eval 'sub mark_disk_removed {
        my($d) = @_;
	    eval q({  ($d->{state}) = (1<<  &MD_DISK_FAULTY) | (1<<  &MD_DISK_REMOVED); });
    }' unless defined(&mark_disk_removed);
    eval 'sub mark_disk_inactive {
        my($d) = @_;
	    eval q({  ($d->{state}) &= ~(1<<  &MD_DISK_ACTIVE); });
    }' unless defined(&mark_disk_inactive);
    eval 'sub mark_disk_nonsync {
        my($d) = @_;
	    eval q({  ($d->{state}) &= ~(1<<  &MD_DISK_SYNC); });
    }' unless defined(&mark_disk_nonsync);
    eval 'sub MD_RECOVERY_RUNNING () {0;}' unless defined(&MD_RECOVERY_RUNNING);
    eval 'sub MD_RECOVERY_SYNC () {1;}' unless defined(&MD_RECOVERY_SYNC);
    eval 'sub MD_RECOVERY_ERR () {2;}' unless defined(&MD_RECOVERY_ERR);
    eval 'sub MD_RECOVERY_INTR () {3;}' unless defined(&MD_RECOVERY_INTR);
    eval 'sub MD_RECOVERY_DONE () {4;}' unless defined(&MD_RECOVERY_DONE);
    eval 'sub MD_RECOVERY_NEEDED () {5;}' unless defined(&MD_RECOVERY_NEEDED);
    eval 'sub mdname {
        my($mddev) = @_;
	    eval q({  ($mddev->{gendisk}) ?  ($mddev->{gendisk}->{disk_name}) : \\"mdX\\"; });
    }' unless defined(&mdname);
    eval 'sub ITERATE_RDEV_GENERIC {
        my($head,$rdev,$tmp) = @_;
	    eval q( &for (($tmp) = ($head). &next; ($rdev) = ( &list_entry(($tmp),  &mdk_rdev_t,  &same_set)), ($tmp) = ($tmp)-> &next, ($tmp)-> &prev != ($head) ; ));
    }' unless defined(&ITERATE_RDEV_GENERIC);
    eval 'sub ITERATE_RDEV {
        my($mddev,$rdev,$tmp) = @_;
	    eval q( &ITERATE_RDEV_GENERIC(($mddev)-> &disks,$rdev,$tmp));
    }' unless defined(&ITERATE_RDEV);
    eval 'sub ITERATE_RDEV_PENDING {
        my($rdev,$tmp) = @_;
	    eval q( &ITERATE_RDEV_GENERIC( &pending_raid_disks,$rdev,$tmp));
    }' unless defined(&ITERATE_RDEV_PENDING);
    eval 'sub THREAD_WAKEUP () {0;}' unless defined(&THREAD_WAKEUP);
    eval 'sub __wait_event_lock_irq {
        my($wq, $condition, $lock) = @_;
	    eval q( &do {  &wait_queue_t  &__wait;  &init_waitqueue_entry(& &__wait,  &current);  &add_wait_queue($wq, & &__wait);  &for (;;) {  &set_current_state( &TASK_UNINTERRUPTIBLE);  &if ($condition)  &break;  &spin_unlock_irq($lock);  &blk_run_queues();  &schedule();  &spin_lock_irq($lock); }  ($current->{state}) =  &TASK_RUNNING;  &remove_wait_queue($wq, & &__wait); }  &while (0));
    }' unless defined(&__wait_event_lock_irq);
    eval 'sub wait_event_lock_irq {
        my($wq, $condition, $lock) = @_;
	    eval q( &do {  &if ($condition)  &break;  &__wait_event_lock_irq($wq, $condition, $lock); }  &while (0));
    }' unless defined(&wait_event_lock_irq);
    eval 'sub __wait_disk_event {
        my($wq, $condition) = @_;
	    eval q( &do {  &wait_queue_t  &__wait;  &init_waitqueue_entry(& &__wait,  &current);  &add_wait_queue($wq, & &__wait);  &for (;;) {  &set_current_state( &TASK_UNINTERRUPTIBLE);  &if ($condition)  &break;  &blk_run_queues();  &schedule(); }  ($current->{state}) =  &TASK_RUNNING;  &remove_wait_queue($wq, & &__wait); }  &while (0));
    }' unless defined(&__wait_disk_event);
    eval 'sub wait_disk_event {
        my($wq, $condition) = @_;
	    eval q( &do {  &if ($condition)  &break;  &__wait_disk_event($wq, $condition); }  &while (0));
    }' unless defined(&wait_disk_event);
}
1;
