require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_RCUPDATE_H)) {
    eval 'sub __LINUX_RCUPDATE_H () {1;}' unless defined(&__LINUX_RCUPDATE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/cache.ph';
	require 'linux/list.ph';
	require 'linux/spinlock.ph';
	require 'linux/threads.ph';
	require 'linux/percpu.ph';
	require 'linux/cpumask.ph';
	eval 'sub RCU_HEAD_INIT {
	    my($head) = @_;
    	    eval q({ . &list =  &LIST_HEAD_INIT( ($head->{list})), . &func =  &NULL, . &arg =  &NULL });
	}' unless defined(&RCU_HEAD_INIT);
	eval 'sub RCU_HEAD {
	    my($head) = @_;
    	    eval q(\'struct rcu_head\' $head =  &RCU_HEAD_INIT($head));
	}' unless defined(&RCU_HEAD);
	eval 'sub INIT_RCU_HEAD {
	    my($ptr) = @_;
    	    eval q( &do {  &INIT_LIST_HEAD(($ptr)-> &list); ($ptr)-> &func =  &NULL; ($ptr)-> &arg =  &NULL; }  &while (0));
	}' unless defined(&INIT_RCU_HEAD);
	eval 'sub RCU_qsctr {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &qsctr));
	}' unless defined(&RCU_qsctr);
	eval 'sub RCU_last_qsctr {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &last_qsctr));
	}' unless defined(&RCU_last_qsctr);
	eval 'sub RCU_batch {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &batch));
	}' unless defined(&RCU_batch);
	eval 'sub RCU_nxtlist {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &nxtlist));
	}' unless defined(&RCU_nxtlist);
	eval 'sub RCU_curlist {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &curlist));
	}' unless defined(&RCU_curlist);
	eval 'sub RCU_QSCTR_INVALID () {0;}' unless defined(&RCU_QSCTR_INVALID);
	eval 'sub rcu_pending {
	    my($cpu) = @_;
    	    eval q({  &if ((! &list_empty( &RCU_curlist($cpu))  &&  &rcu_batch_before( &RCU_batch($cpu),  ($rcu_ctrlblk->{curbatch}))) || ( &list_empty( &RCU_curlist($cpu))  && ! &list_empty( &RCU_nxtlist($cpu))) ||  &cpu_isset($cpu,  ($rcu_ctrlblk->{rcu_cpu_mask}))) 1;  &else 0; });
	}' unless defined(&rcu_pending);
	eval 'sub rcu_read_lock () {
	    eval q( &preempt_disable());
	}' unless defined(&rcu_read_lock);
	eval 'sub rcu_read_unlock () {
	    eval q( &preempt_enable());
	}' unless defined(&rcu_read_unlock);
    }
}
1;
