require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_uPD4990A_H)) {
    eval 'sub _LINUX_uPD4990A_H () {1;}' unless defined(&_LINUX_uPD4990A_H);
    require 'asm/byteorder.ph';
    require 'asm/upd4990a.ph';
    eval 'sub UPD4990A_REGISTER_HOLD () {(0x);}' unless defined(&UPD4990A_REGISTER_HOLD);
    eval 'sub UPD4990A_REGISTER_SHIFT () {(0x1);}' unless defined(&UPD4990A_REGISTER_SHIFT);
    eval 'sub UPD4990A_TIME_SET_AND_COUNTER_HOLD () {(0x2);}' unless defined(&UPD4990A_TIME_SET_AND_COUNTER_HOLD);
    eval 'sub UPD4990A_TIME_READ () {(0x3);}' unless defined(&UPD4990A_TIME_READ);
    eval 'sub UPD4990A_TP_64HZ () {(0x4);}' unless defined(&UPD4990A_TP_64HZ);
    eval 'sub UPD4990A_TP_256HZ () {(0x5);}' unless defined(&UPD4990A_TP_256HZ);
    eval 'sub UPD4990A_TP_2048HZ () {(0x6);}' unless defined(&UPD4990A_TP_2048HZ);
    eval 'sub UPD4990A_TP_4096HZ () {(0x7);}' unless defined(&UPD4990A_TP_4096HZ);
    eval 'sub UPD4990A_TP_1S () {(0x8);}' unless defined(&UPD4990A_TP_1S);
    eval 'sub UPD4990A_TP_10S () {(0x9);}' unless defined(&UPD4990A_TP_10S);
    eval 'sub UPD4990A_TP_30S () {(0xa);}' unless defined(&UPD4990A_TP_30S);
    eval 'sub UPD4990A_TP_60S () {(0xb);}' unless defined(&UPD4990A_TP_60S);
    eval 'sub UPD4990A_INTERRUPT_RESET () {(0xc);}' unless defined(&UPD4990A_INTERRUPT_RESET);
    eval 'sub UPD4990A_INTERRUPT_TIMER_START () {(0xd);}' unless defined(&UPD4990A_INTERRUPT_TIMER_START);
    eval 'sub UPD4990A_INTERRUPT_TIMER_STOP () {(0xe);}' unless defined(&UPD4990A_INTERRUPT_TIMER_STOP);
    eval 'sub UPD4990A_TEST_MODE_SET () {(0xf);}' unless defined(&UPD4990A_TEST_MODE_SET);
    eval 'sub UPD4990A_PAR_SERIAL_MODE () {7;}' unless defined(&UPD4990A_PAR_SERIAL_MODE);
    unless(defined(&UPD4990A_DELAY)) {
	require 'linux/delay.ph';
	eval 'sub UPD4990A_DELAY {
	    my($usec) = @_;
    	    eval q( &udelay(($usec)));
	}' unless defined(&UPD4990A_DELAY);
    }
    unless(defined(&UPD4990A_OUTPUT_DATA)) {
	eval 'sub UPD4990A_OUTPUT_DATA {
	    my($bit) = @_;
    	    eval q( &do {  &UPD4990A_OUTPUT_DATA_CLK(($bit), 0);  &UPD4990A_DELAY(1);  &UPD4990A_OUTPUT_DATA_CLK(($bit), 1);  &UPD4990A_DELAY(1); }  &while (0));
	}' unless defined(&UPD4990A_OUTPUT_DATA);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub upd4990a_serial_command {
        my($command) = @_;
	    eval q({  &UPD4990A_OUTPUT_DATA($command >> 0);  &UPD4990A_OUTPUT_DATA($command >> 1);  &UPD4990A_OUTPUT_DATA($command >> 2);  &UPD4990A_OUTPUT_DATA($command >> 3);  &UPD4990A_DELAY(1);  &UPD4990A_OUTPUT_STROBE(1);  &UPD4990A_DELAY(1);  &UPD4990A_OUTPUT_STROBE(0); } \'struct upd4990a_raw_data\' {  &u8  &sec;  &u8  &min;  &u8  &hour;  &u8  &mday;  &u8  &year; };);
    }' unless defined(&upd4990a_serial_command);
    eval 'sub upd4990a_get_time {
        my($buf,$leave_register_hold) = @_;
	    eval q({ \'int\'  &byte;  &upd4990a_serial_command( &UPD4990A_TIME_READ);  &upd4990a_serial_command( &UPD4990A_REGISTER_SHIFT);  &UPD4990A_DELAY(19);  &for ( &byte = 0;  &byte < 6;  &byte++) {  &u8  &tmp; \'int\'  &bit;  &for ( &tmp = 0,  &bit = 0;  &bit < 8;  &bit++) {  &tmp = ( &tmp | ( &UPD4990A_READ_DATA() << 8)) >> 1;  &UPD4990A_OUTPUT_CLK(1);  &UPD4990A_DELAY(1);  &UPD4990A_OUTPUT_CLK(0);  &UPD4990A_DELAY(1); } (( &u8 *) $buf)[ &byte] =  &tmp; }  &if (!$leave_register_hold)  &upd4990a_serial_command( &UPD4990A_REGISTER_HOLD); });
    }' unless defined(&upd4990a_get_time);
    eval 'sub upd4990a_set_time {
        my($data,$time_set_only) = @_;
	    eval q({ \'int\'  &byte;  &if (!$time_set_only)  &upd4990a_serial_command( &UPD4990A_REGISTER_SHIFT);  &for ( &byte = 0;  &byte < 6;  &byte++) { \'int\'  &bit;  &u8  &tmp = (( &const  &u8 *) $data)[ &byte];  &for ( &bit = 0;  &bit < 8;  &bit++,  &tmp >>= 1)  &UPD4990A_OUTPUT_DATA( &tmp); }  &upd4990a_serial_command( &UPD4990A_TIME_SET_AND_COUNTER_HOLD);  &if (!$time_set_only)  &upd4990a_serial_command( &UPD4990A_REGISTER_HOLD); });
    }' unless defined(&upd4990a_set_time);
}
1;
